#!/bin/bash

me=$(readlink -f $0)
BASE=$(dirname ${me})

if test "$(lsb_release -is)" != "CentOS";then
    read -p "Wrong OS! Please download the Ubuntu or combined update from http://www.ferrari-electronic.de. [Abort]" answer
    exit 2
fi

featureversion=$(featureversion)

if [ ! -z "${featureversion}" ]; then
    if [ -e /tmp/gateconfig.featureversion ]; then
        gateconfigversion=$(cat /tmp/gateconfig.featureversion)
        if [ -z "${gateconfigversion}" -o ${gateconfigversion} -lt ${featureversion} ]; then
            echo "***********************************************************************************"
            echo "* OfficeMaster GateConfiguration too old. Please download new version"
            echo "* http://www.ferrari-electronic.de/fileadmin/download_center/OfficeMasterHardware/Setup-OfficeMaster-Gate-Config.exe"
            echo "***********************************************************************************"
            read -p "OfficeMaster GateConfiguration too old. Please download new version. [Abort/Default=Abort]!" answer
            sleep 5
            echo "## Installation failed ## ..."
            echo "FLASH_FAILED" # Old gateConfig
            touch /tmp/flashfailed
            exit 1
        fi
    else
        if [ -e /var/config.active -o "${HISTFILE}" != "" ]; then
            echo "***********************************************************************************"
            echo "* OfficeMaster GateConfiguration too old. Please download new version"
            echo "* http://www.ferrari-electronic.de/fileadmin/download_center/OfficeMasterHardware/Setup-OfficeMaster-Gate-Config.exe"
            echo "***********************************************************************************"
            read -p "OfficeMaster GateConfiguration too old. Please download new version. [Abort/Default=Abort]!" answer
            sleep 5
            echo "## Installation failed ## ..."
            echo "FLASH_FAILED" # Old gateConfig
            touch /tmp/flashfailed
            exit 2
        fi
    fi
fi

rpmlist=$(find ${BASE} -name '*.rpm')

if test -z "${rpmlist}"; then
    echo "No Packages found."
    exit 1
fi

yum -y --disablerepo=* remove omg omg-modules || exit 1
yum -y --disablerepo=* install ${rpmlist} || exit 1

exit 0
