function getIpAddress()
    local ipAddress
    local ipAddress6
    local handle

    handle = io.open("/tmp/ipaddress","r")
    if handle then
        ipAddress = handle:read("*l")
        io.close()
    end

    handle = io.open("/tmp/ipaddress6","r")
    if handle then
        ipAddress6 = handle:read("*l")
        io.close()
    end

    return ipAddress,ipAddress6
end

mux_sip_dbg = 1
mux_isdn_dbg = 1
mux_jobcontrol_dbg = 1

sip_isdn_dbg = 1
jobcontrol_isdn_dbg=1

command_dbg = 0
ict_dbg=0
ip_dbg=0

-- ----------------------------------------------------------------------

ip_mode = "t"

-- jc-sip pars
sip_default_gateway = os.getenv("SIP_DEFAULT_GATEWAY")
if sip_default_gateway == nil then
    sip_default_gateway = "10.6.0.30"
end

sip_mode = os.getenv("SIP_IP_MODE")
if sip_mode == nil then
    sip_mode = ip_mode
end

-- don't read HOSTNAME anymore ip address is enough
--my_ip_addressw = os.getenv("HOSTNAME")

if my_ip_address == nil then
    my_ip_address,_=getIpAddress()
    if my_ip_address == nil or my_ip_address == "" then
       my_ip_address = os.getenv("IP_ADDRESS")
    end
    if my_ip_address ~= nil then
        my_ip_address = string.gsub(my_ip_address or ""," ","")
    end
end

if my_ip_address6 == nil then
    _,my_ip_address6=getIpAddress()
    if my_ip_address6 == nil then
       my_ip_address6 = os.getenv("IP_ADDRESS6")
    end
    if my_ip_address6 ~= nil then
        my_ip_address6 = string.gsub(my_ip_address6," ","")
        my_ip_address6 = "[" .. my_ip_address6 .. "]"
    end
end

local f
if io ~= nil and io.open ~= nil then
    f = io.open("/data/ipconfig.lua","r")
end
if f then
    io.close(f)

    dofile("/data/ipconfig.lua")
    if ip_address_table ~= nil then
        my_ip_address_table = ip_address_table["V4"]
        my_ip_address6_table = ip_address_table["V6"]
    end
end

tx_t38_invite = "voice only"
autoAnswer = "off"

-- Delay in msec (1000msec = 1sec) before the Re-INVITE is sent
-- after an initial INVITE.
-- A Value of -1 does not send the Re-INVITE at all.
reinvite_delay = 3000


-- mux-sip pars
sip_bind_mode = os.getenv("SIP_BIND_MODE")
if sip_bind_mode == nil then
    if ip_mode == "t" then
        sip_bind_mode = "t"
    else
        sip_bind_mode = "u"
    end
end

sip_bind_address = os.getenv("SIP_BIND_ADDRESS")
if sip_bind_address == nil then
   sip_bind_address = "0.0.0.0"
end

sip_bind_address6 = os.getenv("SIP_BIND_ADDRESS6")
if sip_bind_address6 == nil then
   sip_bind_address6 = "0000:0000:0000:0000:0000:0000:0000:0000"
end

sip_bind_port = os.getenv("SIP_BIND_PORT")
if sip_bind_port == nil then
   sip_bind_port = "5060"
end

isdn_prc = os.getenv("ISDN_PRC")
if isdn_prc == nil then
	isdn_prc = "/usr/fb/bin/isdn.prc"
end

sip_pilot = os.getenv("SIP_PILOT")
if sip_pilot == nil then
	sip_pilot = "999"
end

isGate = nil
local val = os.getenv("GATEWAY")
if val ~= nil then
	if val == "1" then
		isGate = 1
	end
end
val=nil

local slotval = os.getenv("ILID_SLOT")
if slotval ~= nil then
	ilid_slot = slotval
end
