-- ********************************************************************
-- *** :send options Table
-- ********************************************************************

sendHelp="usage: Send (MANDATORY-ARGUMENTS [OPTIONS]) | --help | -h | --version\n" ..
	  " MANDATORY-ARGUMENTS:\n" ..
	  "   -t, --called_party_number       default: \"\"\n" ..
	  "   -B, --bchan_param               default: \"\"\n" ..
	  "\n" ..
	  " OPTIONS:\n" ..
	  "   -b, --bchan_exec                default: \"\"\n" ..
	  "   -f, --calling_party_number      default: \"\"\n" ..
	  "   -i, --client_id                 default: \"\"\n"

sendOptionsTable = {}
sendOptionsTable["t"]="called_party_number"
sendOptionsTable["b"]="bchan_exec"
sendOptionsTable["B"]="bchan_param"
sendOptionsTable["f"]="calling_party_number"
sendOptionsTable["i"]="client_id"
sendOptionsTable["h"]="help"
sendOptionsTable["v"]="version"

function sendInit()
    local t = {}
    t["called_party_number"]=nil;
    t["calling_party_number"]=nil;
    t["bchan_exec"]=nil;
    t["bchan_param"]=nil;
    t["client_id"]=nil;
    return t
end


-- ********************************************************************
-- *** :receive options Table
-- ********************************************************************
receiveHelp = "usage: Receive (MANDATORY-ARGUMENTS [OPTIONS]) | --help | -h | --version\n" ..
	   " MANDATORY-ARGUMENTS:\n" ..
	   "   -i, --channel_id                default: \"\"\n" ..
	   "   -c, --command (accept,hangup)   default: \"accept\"\n" ..
	   "   -B, --bchan_param               default: \"\"\n" ..
	   "   -t, --called_party_number       default: \"\"\n" ..
	   " OPTIONS:\n" ..
	   "   -b, --bchan_exec                default: \"\"\n" ..
	   "   -I, --client_id                 default: \"\"\n" ..
	   "   -f, --calling_party_number      default: \"\"\n"

receiveOptionsTable = {}
receiveOptionsTable["i"]="channel_id"
receiveOptionsTable["c"]="command"
receiveOptionsTable["b"]="bchan_exec"
receiveOptionsTable["B"]="bchan_param"
receiveOptionsTable["I"]="client_id"
receiveOptionsTable["t"]="called_party_number"
receiveOptionsTable["f"]="calling_party_number"
receiveOptionsTable["h"]="help"
receiveOptionsTable["v"]="version"

function reveiveInit()
    local t = {}
    t["channel_id"]=-1;
    t["command"]="accept";
    t["bchan_exec"]=nil;
    t["bchan_param"]=nil;
    t["client_id"]=nil;
    t["called_party_number"]=nil;
    t["calling_party_number"]=nil;
    return t
end

-- ********************************************************************
-- *** :abort options Table
-- ********************************************************************
abortHelp = "usage: Abort (MANDATORY-ARGUMENTS [OPTIONS]) | --help | -h | --version\n" ..
	   " MANDATORY-ARGUMENTS:\n" ..
	   "   -i, --channel_id                default: \"\"\n" ..
	   " OPTIONS:\n" ..
	   "   -I, --client_id                 default: \"\"\n"

abortOptionsTable = {}
abortOptionsTable["i"]="channel_id"
abortOptionsTable["I"]="client_id"
abortOptionsTable["h"]="help"
abortOptionsTable["v"]="version"

function abortInit()
    local t = {}
    t["channel_id"]=-1;
    t["client_id"]=nil;
    return t
end

-- ********************************************************************
-- *** :mwi options Table
-- ********************************************************************
mwiHelp = "usage: Mwi (MANDATORY-ARGUMENTS [OPTIONS]) | --help | -h | --version\n" ..
	   " MANDATORY-ARGUMENTS:\n" ..
	   "   -n, --msg_num                default: \"0\"\n" ..
           "   -m, --method                 default: \"\"\n" ..
           "   -o, --on_string              default: \"\"\n" ..
           "   -f, --off_string             default: \"\"\n" ..
           "   -e, --extension              default: \"\"\n" ..
	   " OPTIONS:\n" ..
	   "   -c, --client_id              default: \"\"\n"

mwiOptionsTable = {}
mwiOptionsTable["n"]="msg_num"
mwiOptionsTable["m"]="method"
mwiOptionsTable["o"]="on_string"
mwiOptionsTable["f"]="off_string"
mwiOptionsTable["e"]="extension"
mwiOptionsTable["c"]="client_id"
mwiOptionsTable["h"]="help"
mwiOptionsTable["v"]="version"

function mwiInit()
    local t = {}
    t["msg_num"]=0;
    t["method"]=nil;
    t["on_string"]=nil;
    t["off_string"]=nil;
    t["extension"]=nil;
    t["client_id"]=nil;
    return t
end

-- ********************************************************************
-- *** :hold options Table
-- ********************************************************************
holdHelp = "usage: Hold (MANDATORY-ARGUMENTS [OPTIONS]) | --help | -h | --version\n" ..
	   " MANDATORY-ARGUMENTS:\n" ..
	   "   -i, --channel_id                default: \"\"\n" ..
	   " OPTIONS:\n" ..
	   "   -I, --client_id                 default: \"\"\n"

holdOptionsTable = {}
holdOptionsTable["i"]="channel_id"
holdOptionsTable["I"]="client_id"
holdOptionsTable["h"]="help"
holdOptionsTable["v"]="version"

function holdInit()
    local t = {}
    t["channel_id"]=-1;
    t["client_id"]=nil;
    return t
end

-- ********************************************************************
-- *** :retrieve options Table
-- ********************************************************************
retrieveHelp = "usage: Retrieve (MANDATORY-ARGUMENTS [OPTIONS]) | --help | -h | --version\n" ..
	   " MANDATORY-ARGUMENTS:\n" ..
	   "   -i, --channel_id                default: \"\"\n" ..
	   " OPTIONS:\n" ..
	   "   -I, --client_id                 default: \"\"\n"

retrieveOptionsTable = {}
retrieveOptionsTable["i"]="channel_id"
retrieveOptionsTable["I"]="client_id"
retrieveOptionsTable["h"]="help"
retrieveOptionsTable["v"]="version"

function retrieveInit()
    local t = {}
    t["channel_id"]=-1;
    t["client_id"]=nil;
    return t
end


-- ********************************************************************
-- *** :s options Table
-- ********************************************************************
sHelp = "usage: s [OPTIONS]) | --help | -h | --version\n" ..
	   "   -c, --count                     default: 1\n"  ..
	   "   -s, --sleep                     default: 250\n"  ..
	   "   -b, --bchan_exec                default: \"\"\n"  ..
	   "   -B, --bchan_param               default: \"\"\n"

sOptionsTable = {}
sOptionsTable["c"]="count"
sOptionsTable["b"]="bchan_exec"
sOptionsTable["B"]="bchan_param"
sOptionsTable["h"]="help"
sOptionsTable["v"]="version"

function sInit()
    local t = {}
    t["count"]=1;
    t["sleep"]=250;
    t["bchan_exec"]=nil;
    t["bchan_param"]=nil;
    return t
end

-- ********************************************************************
-- *** :env options Table
-- ********************************************************************
envHelp = "usage: env [OPTIONS]) | --help | -h | --version\n" ..
	        "       -n, --name\n"

envOptionsTable = {}
envOptionsTable["n"]="name"
envOptionsTable["h"]="help"
envOptionsTable["v"]="version"

function envInit()
    local t = {}
    t["name"]=nil;
    return t
end

-- ********************************************************************
-- *** :c options Table
-- ********************************************************************

cHelp="usage: c [OPTIONS]\n" ..
	  " ARGUMENTS:\n" ..
	  "   -y, --alive (on|off)            default: \"on\"\n" ..
	  "   -d, --dchan_exec                default: \"\"\n" ..
	  "   -D, --dchan_param               default: \"\"\n" ..
	  "   -b, --bchan_exec                default: \"\"\n" ..
	  "   -B, --bchan_param               default: \"\"\n" ..
	  "   -n, --called_party_number       default: \"\" \n" ..
	  "   -N, --calling_party_number      default: \"\" \n" ..
	  "   -L, --log_level                 default: \"\" \n" ..
	  "\n"

cOptionsTable = {}
cOptionsTable["y"]="alive"
cOptionsTable["d"]="dchan_exec"
cOptionsTable["D"]="dchan_param"
cOptionsTable["b"]="bchan_exec"
cOptionsTable["B"]="bchan_param"
cOptionsTable["n"]="called_party_number"
cOptionsTable["N"]="calling_party_number"
cOptionsTable["L"]="log_level"
cOptionsTable["h"]="help"

function cInit()
    local t = {}
    t["alive"]=nil;
    t["dchan_exec"]=nil;
    t["dchan_param"]=nil;
    t["bchan_exec"]=nil;
    t["bchan_param"]=nil;
    t["called_party_number"]=nil;
    t["calling_party_number"]=nil;
    t["log_level"]=nil;
    return t
end



-- ********************************************************************
-- *** all options table
-- ********************************************************************
allOptions={}
allOptions["send"] = sendOptionsTable
allOptions["receive"] = receiveOptionsTable
allOptions["abort"] = abortOptionsTable
allOptions["mwi"] = mwiOptionsTable
allOptions["hold"] = holdOptionsTable
allOptions["retrieve"] = retrieveOptionsTable
allOptions["s"] = sOptionsTable
allOptions["env"] = envOptionsTable
allOptions["c"] = cOptionsTable

-- ********************************************************************
-- *** all init table
-- ********************************************************************
allInit={}
allInit["send"] = sendInit
allInit["receive"] = receiveInit
allInit["abort"] = abortInit
allInit["mwi"] = mwiInit
allInit["hold"] = holdInit
allInit["retrieve"] = retrieveInit
allInit["s"] = sInit
allInit["env"] = envInit
allInit["c"] = cInit

-- ********************************************************************
-- *** all help table
-- ********************************************************************
allHelp={}
allHelp["send"] = sendHelp
allHelp["receive"] = receiveHelp
allHelp["abort"] = abortHelp
allHelp["mwi"] = mwiHelp
allHelp["hold"] = holdHelp
allHelp["retrieve"] = retrieveHelp
allHelp["s"] = sHelp
allHelp["env"] = envHelp
allHelp["c"] = cHelp
 