function printJs(str)
    print(json.encode(str))
end


function bashEscape(str)
    if(str ~= nil and string.match(str,"#") ~= nil)then
        str=string.gsub(str, "#", "\\\\\#")
    end
    return str
end

function changeDate(file)
    attr = lfs.attributes(file)
    if(attr == nil)then
        return(false)
    end
    assert (type(attr))
    return(attr.change)
--	return(attr.modification)
end

function lastModified(file)
	local attributes = lfs.attributes(file)
	if attributes then
    	return(os.date("%c", attributes.modification))
    end
end


function table.reverse ( tab )
    local size = #tab+1
    local newTable = {}

    for i,v in ipairs ( tab ) do
        newTable[size-i] = v
    end

    return newTable
end


function writeTableToFile(table,file)
    local f = io.open(file, "w+")
    if f ~= nil then
       f:write(table)
       f:close()
       return true
    end

    return false
end
 
function getpost()
	local myJson={}
	local post_data={}
	local post_length = tonumber (os.getenv ("CONTENT_LENGTH")) or 0
	if (os.getenv ("REQUEST_METHOD") == "POST" and post_length > 0) then
		local n = tonumber(os.getenv("CONTENT_LENGTH"))
		local post=io.read(n)
		myJson=post
	end
	return myJson
end --function


  function string:split( inSplitPattern, outResults )
      if not outResults then
        outResults = { }
      end
      local theStart = 1
      local theSplitStart, theSplitEnd = string.find( self, inSplitPattern, theStart )
      while theSplitStart do
        table.insert( outResults, string.sub( self, theStart, theSplitStart-1 ) )
        theStart = theSplitEnd + 1
        theSplitStart, theSplitEnd = string.find( self, inSplitPattern, theStart )
      end
      table.insert( outResults, string.sub( self, theStart ) )
      return outResults
    end

function jcInfo()
myTable={}
path="/tmp"
entries = listFiles(path);
i=1
if entries ~= nil then
    entries.n = nil
    table.sort(entries)
    for k, v in pairs(entries) do
	v=string.gsub(v,path.."/","")
	
        if string.find(string.sub( v, 1, 4),"JC%-D") then
            f = io.open ("/tmp/" .. v)
            if f then
		myTable[i]={}
		
                for line in f:lines() do
                    options = SplitCommandlineString(line)
                    -- _, _, D, B = string.find(options["bchannel"],".*%.(%a)/(.-)/")
                       myTable[i]["ilid_index"]=options["ilid_index"]
		    if string.find(options["date"],":") then
        	       myTable[i]["date"]=(string.sub(options["date"],1,16))
                    else
                        myTable[i]["date"]=options["date"]
                    end
                    if string.find(options["partner"],"|") then
                        _,_,ip = string.find(options["partner"],".*|(%d+%.%d+%.%d+%.%d+)|")
                        myTable[i]["ip"]=ip
                    else
                        myTable[i]["ip"]=options["partner"]
                    end
		i=i+1
                end
                f:close()
            end
        end
    end
end
return myTable
end


function cgidecode(str)
  return (str:gsub('+', ' '):gsub("%%(%x%x)", function(xx) return string.char(tonumber(xx, 16)) end))
end


function request_param(name)
		local url = require("socket.url")
        query=os.getenv("QUERY_STRING")
        if(query) then
                for param in string.gmatch(query,"[^&]+") do
                        if(string.match(param,'^'..name..'='))then
                                value=string.gsub(param, name..'=', "")
                                return url.unescape(value)
                        end
                end
        end
end

function stdout2KVtable(cmd,delim)
    local myTable={}
    local i=1
    stdout=os.capture("LC_ALL=C "..cmd,true)
    for line in stdout:gmatch("[^\n\r]+")do
        line = string.gsub(line, '\'', '"')
        myTable[i]={}
        local c=1
        for str in string.gmatch(line, "([^%s]+)") do
            myTable[i][c]=str
            c=c+1
        end
        i=i+1
    end
    return myTable
end


function cmd2kvTable(cmd,delim,valueIndex)
    myTable={}
    mySplit={}
    stdout=os.capture("LC_ALL=C "..cmd.." 2>&1",true)
    for line in stdout:gmatch("[^\n\r]+")do
        if(line ~= nil) then
            mySplit=Split(line,delim)
            if(mySplit[1] ~= nil) then
                myTable[mySplit[1]]=mySplit[valueIndex]
            end
        end
    end
    return myTable
end

function Split(str, delim, maxNb)
    -- Eliminate bad cases...
    if string.find(str, delim) == nil then
        return { str }
    end
    if maxNb == nil or maxNb < 1 then
        maxNb = 0    -- No limit
    end
    local result = {}
    local pat = "(.-)" .. delim .. "()"
    local nb = 0
    local lastPos
    for part, pos in string.gfind(str, pat) do
        nb = nb + 1
        result[nb] = part
        lastPos = pos
        if nb == maxNb then break end
    end
    -- Handle the last field
    if nb ~= maxNb then
        result[nb + 1] = string.sub(str, lastPos)
    end
    return result
end


function stdout2table(cmd)
    local myTable={}
    local i=1
    stdout=os.capture("LC_ALL=C "..cmd,true)
    for line in stdout:gmatch("[^\n\r]+")do
   	    line = string.gsub(line, '\'', '"')
        myTable[i]=line
        i=i+1
    end
    return myTable
end




function file_exists(name)
   local f=io.open(name,"r")
   if f~=nil then io.close(f) 
       return true 
   else 
       return false end
end


function os.captureN(cmd, raw)
  local f = assert(io.popen(cmd, 'r'))
  local s = assert(f:read('*a'))
  f:close()
  if raw then return s end
      s = string.gsub(s, '^%s+', '')
      s = string.gsub(s, '%s+$', '')
      s = string.gsub(s, '[\n\r]+', ' ')
  return s
end

function os.capture(cmd, raw)
  local f = assert(io.popen(cmd, 'r'))
  local s = assert(f:read('*a'))
  f:close()
  if raw then return s end
--      s = string.gsub(s, '^%s+', '')
--      s = string.gsub(s, '%s+$', '')
--      s = string.gsub(s, '[\n\r]+', ' ')
  return s
end

function fileSize(file)
	attr = lfs.attributes (file)
	if(attr == nil)then
		return(false)
	end
	assert (type(attr) == "table")
	return(attr.size)
end

function isDir(path)
    attr = lfs.attributes (path)
    assert (type(attr) == "table")
    if attr.mode == "directory" then
	return true
    else
	return false
    end

end
function getBchannelFiles(path,dchan,bchan)
    if(dchan == nil and bchan == nil)then
        filterStr="BChannelState%-"
    else
        filterStr="BChannelState%-"..dchan.."%-"..bchan.."%-"
    end
    entries=listFiles(path)
    local myTable={}
    if entries ~= nil then
        c=1
        entries.n = nil
        table.sort(entries)
        for k, v in pairs(entries) do
            if string.find(v,filterStr) then
                myTable[c]={}
                myTable[c]=optionTable(v)
                c=c+1
            end
        end
    end
return myTable
end


function optionTable(v) --(v,separator)
    local myTable={}
    f = io.open (v)
    if f then
	for line in f:lines() do
	options = SplitCommandlineString(line)_, _, D, B = string.find(options["bchannel"],"(.-)/(.-)/")
        myTable["dchan"]=(D)
        myTable["bchan"]=B
        myTable["date"]=options["date"]
        myTable["called_party_number"]=options["called-party-number"]
        myTable["calling_party_number"]=options["calling-party-number"]
        myTable["csid"]=options["csid"]
        myTable["error"]=options["error"]
        myTable["type"]=options["type"]
        myTable["bps"]=options["bps"]
        myTable["ecm"]=options["ecm"]
        myTable["res"]=options["res"]
        myTable["t4"]=options["t4"]
        myTable["txp"]=options["txp"]
        myTable["rxp"]=options["rxp"]
        end
    f:close()
    end
return myTable


end






function bchannelTable(file)
    local myTable={}
    local myFiles={}
    if(file == nil) then
        entries = listFiles( "/tmp" );
    else 
		myFiles[1]=file
		entries=myFiles
    end
    if entries ~= nil then
        c=1
        entries.n = nil
        table.sort(entries)
        for k, v in pairs(entries) do
            if string.find(v,"BChannelState") then
                myTable[c]={}
                myTable[c]=optionTable(v)
                c=c+1
	   		end
        end
       	myTable["end"]=c
	    end		
return myTable
end
function connectionTable(option,dchan,bchan)
    if(option == "partial")then
	entries = listFiles( "/tmp" );
	if entries ~= nil then
	        entries.n = nil
	        table.sort(entries)
	        for k, v in pairs(entries) do
    		        if string.find(v,"BChannelState%-"..dchan.."%-"..bchan.."%-") then
		            connections=bchannelTable(v)
			end
		end
	end
    else
       connections=bchannelTable()         --returns a table connections[1...234]=optiontable["calling..."]
    end
	return(json.encode(connections))
end




function messageToTable(data)
        --assert(loadstring(data))()
        --return _m
        
        local f,text
            
        _m = nil
        
        f,text = loadstring(data)
        if f == nil then
            debug(0,"can't interpret '%s'",data or "NIL")
            return nil
        else
            f()
            return _m
        end
end     
        
--[[ This function is generate table to message (only one level)
  ]]    
function tableToMessage(data,s,i)
        if s==nil then s="_m = {}\n" end
        if i==nil then i="_m[\"" end

        for k,v in pairs(data) do
                if (type(v) == "table") then
                        s = s .. i .. k .. "\"\]={}\n"
                        s = tableToMessage(v,s,i .. k .. "\"\][\"")
                elseif (type(v) == "string") then
                local v1,_ = string.gsub(v,"\"","\\\"")
                local v2,_ = string.gsub(v1,"\r\n","\\r\\n\"..\r\n\"")
                s = s .. i .. k .. "\"\]=\"" .. v2 .. "\"\n"
                elseif (type(v) == "boolean") then
                        s = s .. i .. k .. "\"\]=" .. tostring(v) .. "\n"
                else
                        s = s .. i .. k .. "\"\]=" .. v .. "\n"
                end
        end
            
        return s
end     
function tableToConfig(data,s,i)
     local firstLevel=false

    if s == nil then
        firstLevel=true
        s="config = {\n"
    end

    if i==nil then
        i="\t"
    end

    for k,v in pairs(data) do
        if type(v) == "table" then
            if type(k) == "string" then
                s = s .. i .. k .. " = {\n"
            else
                s = s .. i .. "[" .. k .. "]" .. " = {\n"
            end
            s = tableToConfig(v,s,i .. "\t")
            s = s .. i .. "},\n"
        elseif type(v) == "string" then
            local v0,_ = string.gsub(v,"\\","\\\\")
            local v1,_ = string.gsub(v0,"\"","\\\"")
            local v2,_ = string.gsub(v1,"\r\n","\\r\\n\"..\r\n\"")
            if type(k) == "string" then
                s = s .. i .. k .. " = \"" .. v2 .. "\",\n"
            else
                s = s .. i .. "[" .. k .. "]" .. " = \"" .. v2 .. "\",\n"
            end
        elseif type(v) == "boolean" then
            if type(k) == "string" then
                s = s .. i .. k .. " = " .. tostring(v) .. ",\n"
            else
                s = s .. i .. "[" .. k .. "]" .. " = " .. tostring(v) .. ",\n"
            end
        else
            if type(k) == "string" then
                s = s .. i .. k .. " = " .. v .. ",\n"
            else
                s = s .. i .. "[" .. k .. "]" .. " = " .. v .. ",\n"
            end
        end
    end

    s = string.sub(s,1,string.len(s)-2)
    s = s .. "\n"

    if firstLevel == true then
        s = s .. "}\n"
    end

    return s
end

