#!/usr/bin/luaweb
require 'json'
require 'lfs'
dofile('lua.inc')
dofile('cgi.inc')

function getDescription(myFile)
	local description
	f = io.open (myFile)
        if f then
        	for line in f:lines() do
				if string.find(line,"scenario name=") then
                    f:close()
					description=string.gsub(line,'<scenario name="','')
					description=string.gsub(description,'.*:','')
					description=string.gsub(description,'">.*','')
					description=string.gsub(description,"'","-")
					description=string.gsub(description,"[\r\n]+$","") 
 			                   if (description == nil) then
  					    	description="NA"
			        	end
					return description
				end
			end
		end
end

function getCategory(myFile,name)
	local category
	f = io.open (myFile)
        if f then
        	for line in f:lines() do
				if string.find(line,"scenario name=") then
					category=string.gsub(line,'<scenario name="','')
					category=string.gsub(category,name,'')
					category=string.gsub(category,"^%\s",'')
					category=string.gsub(category,"%\s.*",'')
					category=string.gsub(category,':.*','')
					category=string.gsub(category,"'","-")
					category=string.gsub(category,">.*","")
					category=string.gsub(category,"[\r\n]+$","") 
                    if (testCategory == nil) then
  				    	testCategory="NA"
			        end
					return category
				end
			end
		end
end

function getStatus(myFile)
	local status="unknown"
	if io.open(myFile..".ok") then
		status="ok"
	end
	if io.open(myFile..".fail") then
		status="fail"
	end
	return status
end


function string:split(sep)
    local sep, fields = sep or ":", {}
    local pattern = string.format("([^%s]+)", sep)
    self:gsub(pattern, function(c) fields[#fields+1] = c end)
    return fields
end


function createTestTable(files)
	local tests={}
	if files ~= nil then
    	files.n = nil
		table.sort(files)
		length=table.getn(files)
		i=1
		for k, v in pairs(files) do
			v=string.gsub(v,path.."/","")
			if string.find(v,"^[0-9]\.[0-9].+.xml$") and not string.find(v,"pre") and not string.find(v,"post") and not string.find(v,"rec") then
				testName=string.gsub(v,".xml","")
				tempTable=testName:split(".")
				category=tempTable[1]
				subCategory=tempTable[2]
				
				if(tests[category]==nil)then  
				    tests[category]={}
				end
				if(tests[category][subCategory]==nil)then  
				    tests[category][subCategory]={}
				end
                
	  		    tests[category][subCategory][testName]={}
	  			tests[category][subCategory][testName]["category"]=tempTable[1]
	  			tests[category][subCategory][testName]["SubCategory"]=tempTable[2]
	  			tests[category][subCategory][testName]["status"]=getStatus(path..testName)
			   	tests[category][subCategory][testName]["testCategory"]=getCategory(path..testName..".xml",testName)	
	  			tests[category][subCategory][testName]["description"]=getDescription(path..testName..".xml")
 			end
        end
	end
return tests
end


--path="/home/testing/sipp_testing/xml_thomas/"
path="/usr/fb/tests/sipp_xml/"
--needs "/" at the end of path


method=request_param("method")

name=request_param("name")
    if(method == nil)then      --helps debugging
        method="full"
	name="1.9.22"
	method="partial"
    end


if(method==nil)then method=full end

if(method=="full")then
    if (exists(path.."/dotest"))then
    	files = (listFiles(path))
    end
	
elseif(method=="partial")then 
	myFiles={}
	myFiles[1]=path.."/"..name..".xml"
	--print(myFiles[1])
	files=myFiles
end


print ("Content-type: application/json\n")
tab=createTestTable(files)
print ('{ "tests":')
print(json.encode(tab))
print('}')
