#!/usr/bin/luaweb
json = require("json")
omg = require("omg")
dofile('cgi.inc')
dofile('lua.inc')
function printJs(str)
	print(json.encode(str))
end
function help()
	helpText = [===[
	USAGE: 	./omgkeys --key=myKey.pub
	]===]
	print(helpText)
end


local ret={}
local options = omg.splitCommandlineString(arg)
ret["rc"]=0


os.execute("mkdir -p /root/.ssh/; touch /root/.ssh/authorized_keys; chmod 700 /root/.ssh; chmod 600 /root/.ssh/authorized_keys")	--prepare


function isValidOpenSSHKey(key)	--is this a key at all?
	local val=false
	val=os.execute("/usr/bin/ssh-keygen -l -f "..key.." 2>&1 > /dev/null")
	if(val == 0)then val=true end
	return val
end
function isValidPuttyKey(key)
	local val=false
	val=os.execute("ssh-keygen -i -f "..key.." > /dev/null  2>&1")
	if(val == 0)then val=true end
	return val
end
function convertPuttyKey(key)
	local convertedKey=os.captureN("ssh-keygen -i -f "..key)
	return convertedKey
end
function appendKey(str)
	local cmd="grep  -q '"..string.gsub(str, "\n", "").."' /root/.ssh/authorized_keys"		--check if key was already registered
	if(os.execute(cmd) ~= 0)then
		local file = io.open("/root/.ssh/authorized_keys", "a")
		file:write(str)
		file:close()
	else
		ret["rc"]=1
		ret["error"]="Key was already known!"
	end
end
function readFile(key)
	local str
	local file = io.open(key,"r")
	str = file:read("*all")         -- read the whole file
	return str
end


if(options.action == "addkey")then
	if(options.key == nil)then 	help() os.exit(1) end
	ret.key=options.key

	if( exists(options.key) == false)then
		ret["error"]="Key not found!"  	
		ret["rc"]=1
	else
		ret["type"]=nil	--explicitly
		if(isValidOpenSSHKey(options.key) == true)then
			ret["type"]="openSSH"
		elseif(isValidPuttyKey(options.key) == true)then
			ret["type"]="putty"
		else
			ret["type"]="unknown"
			ret["error"]="This is not a public key!"
			ret["rc"]=1
		end

		if(ret["type"]== "putty")then
			appendKey( convertPuttyKey(options.key).."\n" )  --convert and append
		end
	
		if(ret["type"] == "openSSH" )then
			appendKey( readFile(options.key) )
		end
	end	--end exists
	elseif(options.action == "listKeys")then
		ret["keys"]=stdout2table("ls -l /root/.ssh/id_* 2>/dev/null")
		ret["rc"]=0
	elseif(options.action == "generateKey")then
		ret["cmd"]=stdout2table('echo -e "y" | ssh-keygen -t rsa -N "" -f /root/.ssh/id_rsa')
		ret["rc"]=0
	else
		ret["rc"]=1
		ret["error"]="No action was specified!"
end




omg.runScript(ret,arg,"collects system information\n")


