#!/usr/bin/luaweb

function exists(filename)
local file = io.open(filename)
    if file then
        io.close(file)
        return true
    else
        return false
    end
end

if(exists("/usr/fb/tests/system_tests/testdefinition.lua"))then
    dofile('/usr/fb/tests/system_tests/tests.inc')
    dofile('/usr/fb/tests/system_tests/testdefinition.lua')
    require 'json'
else
	print ("Content-type: application/json\n")
    print('{"end":"end"}')
    os.exit(1)
end
dataDir = os.getenv("DATA_DIR") or "/data"
dofile(dataDir .. "/config.lua")
result="failed"

if(config.struct_Box.string_SipTlsBindPort ~= nil)then
	tests[4]["description"]="checking SipTlsBind port "..config.struct_Box.string_SipTlsBindPort.."/tcp..."
end
tests[5]["description"]="checking callp port "..config.struct_Box.string_SipBindPort.."/tcp..."
tests[5]["parameter"]="tcp "..config.struct_Box.string_SipBindPort


---www-data needs to be in sudoers (getchannels)
path="/usr/fb/tests/system_tests/"

output="stdout"
if(request_param("json")~=nil )then
	output="json"
end
output="json"

results={}
i=1
for index,test in pairs(tests)do
	description=test["description"]
	command=test["command"]
	parameter=test["parameter"]
	name=test["name"]

	--execute the test, pass args
	--
	if(index == 4 and config.struct_Box.string_SipTlsBindPort == nil)then
		
	else
		--result=os.capture("/usr/bin/sudo "..path..command.." "..parameter)
		result=os.capture(path..command.." "..parameter)

-- create result table --
	results[i]={}
	results[i]["name"]=name
	results[i]["description"]=description
	if(result=="") then result="failed" end
	results[i]["result"]=result
i=i+1	
	end
end


--if run from commandLine just output all failed tests, and exit with number of failed
if(output == "stdout")then
	retval=0
	for index,result in pairs(results)do
		if(result["result"]~="ok")then
			print(result["description"]..result["result"])
			retval=retval+1		
		end
	end
os.exit(retval)
end

--if run from web output json data
if(output == "json")then 
	print ("Content-type: application/json\n")
	print(json.encode(results))
end

