
    _ = require('lodash'),
    aggConfig = require("/data/config.json").agg,
zmq 			= require('zmq'),
    aggregator = zmq.socket('pull'),
    replacer = zmq.socket('pull'),
    responder = zmq.socket('rep'),
    frontend = zmq.socket('pub'),
    zmqReplacePublisher = zmq.socket('pub'),
    zmqDottedPublisher = zmq.socket('pub'),
    path = require("path");


var environment = require("/data/config.json").environment;
var omg = {};
var modulesNeeded = ['logger', 'helperfunctions'];

if (environment === "dev") {
    _.each(modulesNeeded, function(modName) {
        omg[modName] = require(__dirname + "/../../ferrariJS/omg-" + modName + "/");
    });
} else if (environment === "prod") {
    _.each(modulesNeeded, function(modName) {
        omg[modName] = require("omg-" + modName);
    });
}
var helper = omg.helperfunctions;
var logger = omg.logger;

var json = {};

responder.jsend = function(msg) {
    responder.send(JSON.stringify(msg))
};


var host = aggConfig.protocol + "://*:";


// aggregator.bindSync(host + aggConfig.sendPort); //send data here
// replacer.bindSync(host + aggConfig.replacePort); // replaces path

// responder.bindSync(host + aggConfig.resPort); // responds to dotted path and returns an object

// frontend.bindSync(host + aggConfig.subAllPort); // if you subscribe here, you get all changes
// zmqReplacePublisher.bindSync(host + aggConfig.replaceBroadcPort); // broadcasts replacements
// zmqDottedPublisher.bindSync(host + aggConfig.subDottedPort); // subscribe by dotted path



function getPath(a) {
    var list = [];
    (function(o, r) {
        r = r || '';
        if (typeof o != 'object') {
            return true;
        }
        for (var c in o) {
            if (typeof(o[c] == "object")) {
                if (c.indexOf(".") != -1) {
                    list.push(r.substring(1) + ".[" + c + "].");
                } else {
                    list.push(r.substring(1) + "." + c);
                }
            }
            var b;
            if (c.indexOf(".") != -1) {
                b = ".[" + c + "]";
                arguments.callee(o[c], r + b)
            } else {
                b = c;
                arguments.callee(o[c], r + "." + b)
            }
        }

    })(a);
    return _.unique(_.map(list, function(item) {
        item = item.replace(/\.$/, "").replace(/^\./, "")
        return item;
    }));
}



aggregator.on('message', function(msg) {

    try {
        msg = JSON.parse(String(msg));
        frontend.send(msg);
    } catch (e) {
        logger.error(e.message)
        // console.log(msg.toString());
        // logger.error("!!!unable to parse msg", e);
        return false;
    }

    //console.log(getPath(msg))
    _.each(getPath(msg), function(path, i) {
        if (path !== "") {
            if (_.isEqual(helper.getPropByString(msg, path), helper.getPropByString(json, path)) === false) {
                var update = {}; //create empty object
                helper.setObjPath(update, path, helper.getPropByString(msg, path)); //create path {dynamic.uptime}, set value
                zmqDottedPublisher.send(path + ":" + JSON.stringify(update));

            } else {
                //console.log("no change")
            }
        }
    });
    zmqDottedPublisher.send("json:" + JSON.stringify(msg));
    _.merge(json, msg);
});

replacer.on("message", function(msg) {
    function broadCastChannelsUp(path, data) {
        var chans = path.split(".");
        while (chans.length) {
            str = chans.join(".");
            var msg = str + ":" + path + ":" + data; //console.log(str + "\t\t:" + path + "\t\t" + data);
            zmqReplacePublisher.send(msg);
            chans.pop();
        }
    }
    msg = String(msg);
    var index = msg.indexOf(':');
    var path = msg.substring(0, index);
    var data = msg.substring(index + 1);
    if (!path.length) {
        throw "no path to replace!";
    } //throw
    var replaced = helper.replaceByString(json, path, data);
    if (replaced) {
        broadCastChannelsUp(path, data);
    } else {
        //console.log("discarded update: " + data)
    }
});

responder.on("message", function(msg) { //will respond with the whole json or query-results
    var res = []; //reply is always an array
    var query = JSON.parse(msg.toString()) //toString needed here!?

    switch (query.method) {
        case "byKey": //returns single object, or undefined
            res.push(_.find(json, function(obj, key) {
                return key === query.key
            }));
            responder.jsend(res);
            break;
        case "byMatch": //returns array of matches (no ids in here!)
            res = _.where(json, query.match);
            responder.jsend(res);
            break;
        case "dotted":
            res = helper.getPropByString(json, query.match);
            var obj = {};
            //console.log("dooooootentdd")
            helper.setObjPath(obj, query.match, res); //construct full object by path {dynamic:{.. :data}}
            responder.send(query.id + ":" + JSON.stringify(obj));
            break;
        case "any":
            res = json;
            responder.jsend(res);
            break;
    }
});





// _.merge(json, {
//     dynamic: {
//         connectionTable: {
//             "cc58fa10-fe32-11e3-b161-03456e737a48": {
//                 "address": "10.0.0.130",
//                 "proto": "tcp",
//                 "port": "5060",
//                 "disabled": "yes",
//                 "resolved": {
//                     "192.168.1.1": {
//                         portProbe: true
//                     }
//                 },
//                 "id": "cc58fa10-fe32-11e3-b161-03456e737a48"
//             }
//         }
//     }
// });
// helper.getPropByString(json, "dynamic.connectionTable.cc58fa10-fe32-11e3-b161-03456e737a48.resolved.[192.168.1.1]")

/*
replacer.rsend("dynamic.test.cars.date2","xxx")		//replace
replacer.rsend("dynamic.test.cars.date1")			//delete

will broadcast to channels:
'dynamic.test.cars: dynamic.test.cars : 			{obj}';
'dynamic.test     : dynamic.test.cars : 			["a","b","c"]';
'dynamic          : dynamic.test.cars : 			xxx';
*/