// Generated by CoffeeScript 1.9.0
var clients, convertZmqResponse, environment, exec, fs, io, isStandardServer, logger, modulesNeeded, omg, pubSub, pubSubRooms, reqRepRooms, requestReply, webtozmqproxys, writeConfig, _;

_ = require("lodash");

exec = require("child_process").exec;

fs = require('fs');

environment = global.appConfig.environment;

omg = {};

modulesNeeded = ["logger", "webtozmqproxys", "server", "helperfunctions"];

if (environment === "dev") {
  _.each(modulesNeeded, function(modName) {
    omg[modName] = require("../../ferrariJS/omg-" + modName + "/");
  });
} else if (environment === "prod") {
  _.each(modulesNeeded, function(modName) {
    omg[modName] = require("omg-" + modName);
  });
}

io = omg.server.io;

logger = omg.logger;

webtozmqproxys = omg.webtozmqproxys;

requestReply = webtozmqproxys.requestReply;

pubSub = webtozmqproxys.pubSub;

clients = [];

pubSubRooms = {};

reqRepRooms = {};

convertZmqResponse = function(response) {
  var producer;
  response = String(response);
  response = response.split(" ");
  producer = response[0];
  response.shift();
  response = response.join(" ");
  return [producer, response];
};

pubSub.register(function(err, response) {
  var convertedResponse, producer, responseMessage;
  convertedResponse = convertZmqResponse(response);
  producer = convertedResponse[0];
  responseMessage = convertedResponse[1];
  return io.sockets["in"](producer).emit(producer, responseMessage);
});

requestReply.register(function(err, response) {
  var convertedResponse, i, producer, responseMessage, _results;
  convertedResponse = convertZmqResponse(response);
  producer = convertedResponse[0];
  responseMessage = convertedResponse[1];
  if (reqRepRooms[producer]) {
    i = reqRepRooms[producer].length - 1;
    _results = [];
    while (i >= 0) {
      reqRepRooms[producer][i].emit(producer, responseMessage);
      reqRepRooms[producer].splice(i, 1);
      if (reqRepRooms[producer].length < 1) {
        delete reqRepRooms[producer];
      }
      _results.push(i--);
    }
    return _results;
  }
});

writeConfig = function() {
  return fs.writeFileSync("/data/config.json", JSON.stringify(global.appConfig, void 0, 4));
};

isStandardServer = false;

if (global.appConfig.server.port === 80) {
  isStandardServer = true;
}

io.on("connection", function(socket) {
  socket.emit("serverConfig", global.appConfig);
  socket.on("toggleStandardServer", function(thatOne) {
    if (!thatOne) {
      switch (global.appConfig.server.port) {
        case 8080:
          thatOne = "node";
          break;
        case 80:
          thatOne = "apache";
      }
    }
    if (thatOne === "node") {
      global.appConfig.server.port = 80;
      global.appConfig.server.restartApache = true;
      writeConfig();
      exec('sed -i -e "s#Listen 80#Listen 8080#" /etc/httpd/conf/httpd.conf; service httpd stop', function(error, stdout, stderr) {
        if (error) {
          console.log(error);
        }
        if (stdout) {
          console.log(stdout);
        }
        if (stderr) {
          console.log(stderr);
        }
        return exec("service omgWebInterface restart", function(error, stdout, stderr) {
          if (error) {
            console.log(error);
          }
          if (stdout) {
            console.log(stdout);
          }
          if (stderr) {
            return console.log(stderr);
          }
        });
      });
    }
    if (thatOne === "apache") {
      global.appConfig.server.port = 8080;
      global.appConfig.server.restartApache = true;
      writeConfig();
      return exec('sed -i -e "s#Listen 8080#Listen 80#" /etc/httpd/conf/httpd.conf; service httpd stop', function(error, stdout, stderr) {
        if (error) {
          console.log(error);
        }
        if (stdout) {
          console.log(stdout);
        }
        if (stderr) {
          console.log(stderr);
        }
        return exec("service omgWebInterface restart", function(error, stdout, stderr) {
          if (error) {
            console.log(error);
          }
          if (stdout) {
            console.log(stdout);
          }
          if (stderr) {
            return console.log(stderr);
          }
        });
      });
    }
  });
  return socket.on("producerAction", function(requestObject) {
    var producer, subscriptionActivity;
    if (requestObject.rMethod === "reqrep") {
      producer = requestObject.producer;
      reqRepRooms[producer] = reqRepRooms[producer] || [];
      if (reqRepRooms[producer].indexOf(socket) === -1) {
        reqRepRooms[producer].push(socket);
        requestReply.request(requestObject);
        logger.debug("reqrep " + producer + ":" + reqRepRooms[producer].length);
      }
    }
    if (requestObject.rMethod === "pubsub") {
      subscriptionActivity = requestObject.pAction;
      producer = requestObject.producer;
      if (subscriptionActivity === "subscribe") {
        socket.join(producer);
        pubSub.subscribe(requestObject);
      }
      if (subscriptionActivity === "unsubscribe") {
        socket.leave(producer);
        pubSub.unsubscribe(requestObject);
      }
      if (subscriptionActivity === "start" || subscriptionActivity === "stop") {
        pubSub.execute(requestObject);
      }
    }
    return socket.on("disconnect", function() {
      return _.each(reqRepRooms, function(room) {
        return logger.debug(room);
      });
    });
  });
});

setInterval((function() {
  var usedRooms;
  usedRooms = _.map(io.rooms, function(clientsInRoom, roomName) {
    return roomName;
  });
  if (usedRooms.length) {
    logger.debug("refreshing " + usedRooms.length + " rooms");
    _.each(usedRooms, function(producerName, index) {
      var requestObject;
      if (!producerName) {
        return;
      }
      producerName = producerName.replace("/", "");
      requestObject = {
        rMethod: "pubsub",
        pAction: "subscribe",
        producer: producerName
      };
      pubSub.subscribe(requestObject);
    });
  }
}), 20 * 1000);
