// Generated by CoffeeScript 1.8.0
'use strict';
var exec, fs, isWatching, logger, watcher, _;

_ = require("lodash");

fs = require('fs');

exec = require("child_process").exec;

logger = require("omg-logger");

isWatching = false;

watcher = false;


/**
    * Starts watching for changes on /tmp/ (can only be started once)
    * @param  {Function}  callback  function that should be called with new channel logs
    * @return  {callback}  (null, channelLogs)
 */

exports.start = function(callback) {
  var onSomethingChanged, watchDir;
  if (!isWatching) {
    isWatching = true;
    watchDir = "/tmp/";

    /*
    checks if changed file was BChannelState, then runs getChannelLogs.lua and returns result through callback
     */
    onSomethingChanged = function(event, filename) {
      if (filename.lastIndexOf("BChannelState", 0) === 0 || filename.lastIndexOf("isdn-call-", 0) === 0) {
        return exec("./getChannelLogs.lua", {
          cwd: __dirname + "/lua/"
        }, function(error, stdout, stderr) {
          var returnObject;
          if (error) {
            logger.error(error);
          }
          if (stderr) {
            logger.warn(stderr);
          }
          logger.debug("sending callinfo changes because " + filename + " changed");
          returnObject = {};
          stdout = JSON.parse(stdout);
          _.each(stdout, function(call) {
            return returnObject[call.name] = call;
          });
          return callback(null, returnObject);
        });
      }
    };

    /*! */
    return watcher = fs.watch(watchDir, onSomethingChanged);
  }
};


/**
    * stop watching for file changes. This actually never get's called (why should it?)
 */

exports.stop = function(force) {
  if (!_.isFunction(force)) {
    isWatching = false;
    return watcher.close();
  }
};
