var exec = require('child_process').exec;
var _ = require("lodash");

var environment = require("/data/config.json").environment || 'dev';
var omg = {};
var modulesNeeded = ['logger'];

if (environment === "dev") {
    _.each(modulesNeeded, function(modName) {
        omg[modName] = require("../../omg-" + modName + "/");
    });
} else if (environment === "prod") {
    _.each(modulesNeeded, function(modName) {
        omg[modName] = require("omg-" + modName);
    });
}

var logger = omg.logger;

exports.jsonCmd = function(command, next) {
    switch (command) {
        case "getstates --json":
            break;
        default:
            return next("invalid command");
    }
    exec(command, function(error, stdout) {
        if (error) {
            return next(error, null);
        }
        try {
            next(null, JSON.parse(stdout));
        } catch (e) {
            next(e, null);
        }
    });
};

exports.cmd2string = function(command, next) {
    var options = {
        maxBuffer: 1024 * 500
    }

    switch (command) {
        case "ls":
            break;
        case "ifconfig":
            command = "ifconfig -a";
            break;
        case "pscallp":
            break;
        case "dmesg":
            break;
        case "ps ax":
            break;
        case "netstat":
            command = "netstat -an --inet";
            break;
        case "getchannels":
            break;
        default:
            return next("invalid command!");
    }
    command = "LC_ALL=C " + command;
    exec(command, options, function(error, stdout, stderr) {
        if (error || stderr) {
            logger.warn("command FAILED: " + command);
        }
        try {
            if (error) {
                return next(error, null);
            }
            if (command === "LC_ALL=C getchannels" && stderr && !stdout) { // getchannels returns its channels on stderr...??
                stdout = stderr;
            }
            next(null, stdout);
        } catch (e) {
            next(e);
            logger.warn(e.message);
        }
    });
};