// Generated by CoffeeScript 1.9.0

/*
* omg-configurator
*
* Copyright (c) 2014 Johannes Noe
* Licensed under the MIT license.
 */
'use strict';
var exec, extracted_struct_DChannel, fs;

fs = require('fs');

exec = require("child_process").exec;

exports.start = function(callback) {
  return callback(null, "omg_configurator");
};

exports.set = function(filename, configuration, startCallback, outputCallback) {
  var filepath;
  switch (filename) {
    case "config.lua":
      filepath = "/data/config.lua";
      break;
    case "config.test":
      filepath = "/data/config.test";
      break;
    default:
      if (startCallback) {
        startCallback("I don't know that config file!");
      }
      outputCallback("I don't know that config file!");
      return;
  }
  if (startCallback) {
    startCallback(null, "writing " + filepath);
  }
  return exec(__dirname + "/lua/writeConfig.lua " + filepath + " '" + configuration + "'", function(error, stdout, stderr) {
    if (error) {
      console.log(error);
    }
    if (stderr) {
      console.log(stderr);
    }
    return outputCallback(null, JSON.parse(configuration));
  });
};

extracted_struct_DChannel = function(data) {
  return data.config.struct_Box.struct_DChannel;
};

exports.get = function(filename, startCallback, outputCallback) {
  var filepath, preCallback;
  switch (filename) {
    case "config.lua":
      filepath = "/data/config.lua";
      break;
    case "config.lua struct_DChannel":
      filepath = "/data/config.lua";
      preCallback = extracted_struct_DChannel;
      break;
    case "config.test":
      filepath = "/data/config.test";
      break;
    default:
      if (startCallback) {
        startCallback("I don't know that config file!");
      }
      outputCallback("I don't know that config file!");
      return;
  }
  if (startCallback) {
    startCallback(null, "reading " + filepath);
  }
  return exec(__dirname + "/lua/readConfig.lua '" + filepath + "'", function(error, stdout, stderr) {
    if (error) {
      console.log(error);
    }
    if (stderr) {
      console.log(stderr);
    }
    stdout = JSON.parse(stdout);
    if (preCallback) {
      stdout = preCallback(stdout);
    }
    return outputCallback(null, stdout);
  });
};
