// Generated by CoffeeScript 1.8.0
"use strict";
var CoreDumpCheck, EventEmitter, events, exec, fs, logger, temp, _,
  __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

_ = require("lodash");

fs = require('fs');

exec = require("child_process").exec;

logger = require("omg-logger");

events = require('events');

EventEmitter = require('events').EventEmitter;

CoreDumpCheck = (function(_super) {
  __extends(CoreDumpCheck, _super);

  function CoreDumpCheck() {
    this["delete"] = __bind(this["delete"], this);
    var checkNewDumpFiles, readDumpFiles, tempDumpFiles, watcher;
    this.watchDir = "/usr/fb/bin/sipisdn/";
    this.dumpFiles = [];
    tempDumpFiles = [];
    checkNewDumpFiles = (function(_this) {
      return function() {
        if (tempDumpFiles.length !== _this.dumpFiles.length) {
          tempDumpFiles = _this.dumpFiles;
          _this.emit("reset");
          return _this.emit("data", _this.dumpFiles);
        }
      };
    })(this);
    setInterval(checkNewDumpFiles, 1000);
    readDumpFiles = (function(_this) {
      return function() {
        return fs.readdir(_this.watchDir, function(error, files) {
          var fileName;
          if (error) {
            logger.error(error);
          }
          return _this.dumpFiles = (function() {
            var _i, _len, _results;
            _results = [];
            for (_i = 0, _len = files.length; _i < _len; _i++) {
              fileName = files[_i];
              if (fileName.lastIndexOf("core", 0) === 0) {
                _results.push({
                  name: fileName,
                  time: (new Date()).toString()
                });
              }
            }
            return _results;
          })();
        });
      };
    })(this);
    readDumpFiles();
    watcher = fs.watch(this.watchDir, (function(_this) {
      return function(event, filename) {
        if (filename.lastIndexOf("core", 0) === 0) {
          return readDumpFiles();
        }
      };
    })(this));
  }

  CoreDumpCheck.prototype.start = function() {
    return logger.debug("coredumpcheck is a watcher and does not need to be started");
  };

  CoreDumpCheck.prototype["delete"] = function(file, startCallback, outputCallback) {
    startCallback();
    if (file === "all") {
      logger.silly("deleting all core dumps");
      return fs.readdir(this.watchDir, (function(_this) {
        return function(error, files) {
          var dumpFiles, fileName;
          if (error) {
            logger.error(error);
          }
          dumpFiles = (function() {
            var _i, _len, _results;
            _results = [];
            for (_i = 0, _len = files.length; _i < _len; _i++) {
              fileName = files[_i];
              if (fileName.lastIndexOf("core", 0) === 0) {
                _results.push(fileName);
              }
            }
            return _results;
          })();
          _.each(dumpFiles, function(fileName) {
            return fs.unlink("" + _this.watchDir + fileName);
          });
          return outputCallback(null, []);
        };
      })(this));
    } else {
      return fs.unlink("" + this.watchDir + file);
    }
  };

  CoreDumpCheck.prototype.getStatus = function(callback) {
    logger.silly("getStatus");
    this.emit("data", this.dumpFiles);
    if (callback) {
      return callback(null, this.dumpFiles);
    }
  };

  return CoreDumpCheck;

})(EventEmitter);

temp = new CoreDumpCheck();

module.exports = temp;
