var _ = require("lodash");
var os = require("os");


exports.start = function(callback) {
    var timeout = 1;
    var old = _.map(os.cpus(), function(cpu) {
        return cpu.times;
    });

    setTimeout(function() {
        var result = [];
        var current = _.map(os.cpus(), function(cpu) {
            return cpu.times;
        });
        _.each(current, function(item, cpuKey) {
            result[cpuKey] = {};

            var oldVal = old[cpuKey];
            _.each(_.keys(item), function(timeKey) {
                var diff = (parseFloat((item[timeKey]) - parseFloat(oldVal[timeKey])) / parseFloat((timeout * 100)));
                var name = timeKey;
                if (timeKey === "idle") {
                    name = "CPU";
                    diff = 100 - diff;
                }
                //console.log(timeKey + ":\t" + oldVal[timeKey] + "\t\t" + item[timeKey] + "\t\t" + diff);
                result[cpuKey][name] = diff.toFixed(0);
            });
        });
        old = current;
        callback(null, result);
    }, (timeout * 1000));
};