#!/usr/bin/luaweb
require("json")
require("lfs")

function os.captureN(cmd, raw)
  local f = assert(io.popen(cmd, 'r'))
  local s = assert(f:read('*a'))
  f:close()
  if raw then return s end
      s = string.gsub(s, '^%s+', '')
      s = string.gsub(s, '%s+$', '')
      s = string.gsub(s, '[\n\r]+', ' ')
  return s
end

function os.capture(cmd, raw)
  local f = assert(io.popen(cmd, 'r'))
  local s = assert(f:read('*a'))
  f:close()
  if raw then return s end
  return s
end

function probeDNS(address)
    local result={}
    start=os.time()
    result["valid"]=os.captureN("LC_ALL=C /usr/bin/nslookup -q=any "..address.." "..address.."  | grep -q ';; connection timed out; no servers could be reached' && echo false || echo true")
    stop=os.time()

    result["address"]=address
    result["elapsed"]="("..os.difftime(os.time(),start).."s)"
    return result
end

function stdout2table(cmd)
    local myTable={}
    local i=1
    stdout=os.capture("LC_ALL=C "..cmd,true)
    for line in stdout:gmatch("[^\n\r]+")do
   	    line = string.gsub(line, '\'', '"')
        myTable[i]=line
        i=i+1
    end
    return myTable
end

local nameservers = {}
nameservers={}
nameservers.plain=stdout2table('cat /etc/resolv.conf | grep -v ^#')
local servers = stdout2table('cat /etc/resolv.conf | grep ^nameserver | awk -F " " \'{print $2}\'')
local resolveTable={}
for k,address in pairs(servers) do
	resolveTable[k]=probeDNS(address)
end
nameservers.stats=resolveTable

print(json.encode(nameservers));