/*
 * omg-exec
 *
 * Copyright (c) 2014 Johannes Noe
 * Licensed under the MIT license.
 */

'use strict';

var exec = require('child_process').exec;
var _ = require("lodash");

var logger = require("omg-logger");



exports.getConnectedServers = function(next) {
    exec('cat /tmp/JC-D* | awk -F \'"\' \'{print $2 " " $4 " " $6}\' ', function(error, stdout) { //omitted ,stderr
        try {
            var obj = {};
            var split = stdout.split("\n");
            _.each(split, function(line) {
                if (line !== "") {
                    var cols = line.split(" ");
                    obj[cols[0]] = [cols[1], cols[2]];
                }
            });
            next(null, obj);
        } catch (e) {
            logger.error(e);
            next(e);
        }


    });
};

exports.getUptime = function(next) {
    var arr = [];
    exec("LC_ALL=C uptime", function(error, stdout) { //omitted ,stderr
        /*stdout=" 14:54:17 up 22:13,  6 users,  load average: 0.01, 0.15, 0.18";
			stdout=" 17:32:46 up 5 days, 25 min,  8 users,  load average: 0.29, 0.50, 0.54"
			stdout=" 17:34:58 up 1 day, 54 min,  4 users,  load average: 0.00, 0.00, 0.00"
			stdout=" 17:35:56 up 0 min,  1 user,  load average: 0.60, 0.13, 0.04"*/



        // stdout = stdout.trim();
        // var upIdx = stdout.indexOf("up");
        // arr[0] = stdout.substring(0, upIdx);
        // var rest = stdout.substring(upIdx).replace("up ", "");

        // if (rest.indexOf("users") !== -1) {
        //     arr[1] = rest.split(/users/)[0] + "users";
        // } else if (rest.indexOf("user") !== -1) {
        //     arr[1] = rest.split(/user/)[0] + "user";
        // }
        // var sload = rest.split('load average:')[1];
        // var load = sload.split(/,/);

        // arr = arr.concat(load);
        // if (arr.length !== 5) {
        //     logger.error("ERROR IN UPTIME parseing! - continue with junk data?");
        //     throw new Error("uptime failed");
        // }

        next(error, stdout);
    });
};

exports.getProcs = function(next) {
    exec("LC_ALL=C ps ax", function(error, stdout) {
        if (error) {
            throw error;
        }
        var lines = stdout.split("\n");
        lines = _.map(lines, function(item) {
            return _.without(item.split(/\s{2,}/), "");
        });
        next(lines);
    });
};

exports.getPsCallp = function(next) {
    exec("LC_ALL=C pscallp", function(error, stdout) {
        if (error) {
            console.log("problem executing pscallp ! - missing firmware parts ?");
        }
        next(stdout);
    });
};