// Generated by CoffeeScript 1.8.0

/*
* omg-hostinspection
*
* Copyright (c) 2014 Johannes Noe
* Licensed under the MIT license.
 */
'use strict';
var appConfig, runAsRoot, spawn;

spawn = require("child_process").spawn;

appConfig = global.appConfig;

if (appConfig) {
  runAsRoot = appConfig.sudo || false;
}

exports.start = function(commandObject, startCallback, outputCallback) {
  var args, command, host, port, proto, runningCommand;
  command = commandObject.command;
  args = commandObject.args || [];
  host = commandObject.host || "127.0.0.1";
  proto = commandObject.proto || "tcp";
  port = commandObject.port || "5060";
  switch (command) {
    case "ping":
      args = ["-c", "4", host];
      break;
    case "tracepath":
      args.push(host);
      break;
    case "dnsLookup":
      command = "dig";
      args.push(host);
      break;
    case "portScan":
      if (runAsRoot) {
        command = "sudo";
        args = ["nmap", "-PO", "-vv"];
      }
      if (!runAsRoot) {
        command = "nmap";
        args = ["-PO", "-vv"];
      }
      if (proto === "tcp") {
        args.push("tcp");
      }
      if (proto === "udp") {
        args.push("-sU");
      }
      args.push(host);
      break;
    case "portProbe":
      if (runAsRoot) {
        command = "sudo";
        args = ["nmap", "-PO", "-vv"];
      }
      if (!runAsRoot) {
        command = "nmap";
        args = ["-PO", "-vv"];
      }
      if (proto === "tcp") {
        args.push("-sT");
      }
      if (proto === "udp") {
        args.push("-sU");
      }
      args.push(host);
      args.push("-p");
      args.push(port);
      break;
    default:
      startCallback("command invalid");
  }
  startCallback(null, "" + command + " " + args);
  runningCommand = spawn(command, args);
  runningCommand.stdout.on("data", function(data) {
    var lines;
    lines = data.toString('utf-8');
    lines = lines.split('\n');
    return outputCallback(null, lines);
  });
  return runningCommand.on("close", function(returnCode) {
    return outputCallback("regular stop", returnCode);
  });
};
