// Generated by CoffeeScript 1.8.0

/*
 * omg-isdnconnectionsstate
 *
 * Copyright (c) 2014 Johannes Noe
 * Licensed under the MIT license.
 */
'use strict';
var exec, fs, isWatching, wait, watcher, _;

exec = require("child_process").exec;

_ = require("lodash");

fs = require('fs');

isWatching = false;

wait = false;

watcher = false;

exports.start = function(callback) {
  var runGetStates, watchDir;
  runGetStates = function() {
    wait = true;
    return exec("LC_ALL=C getstates", function(error, stdout) {
      var col, cols, e, item, key, line, lines, sep, splitStdout, states, val, _i, _len;
      setTimeout(function() {
        return wait = false;
      }, 2000);
      states = {};
      splitStdout = stdout.split("\n");
      lines = _.without(splitStdout, "");
      for (key in lines) {
        line = lines[key];
        item = {};
        cols = line.split(", ");
        for (_i = 0, _len = cols.length; _i < _len; _i++) {
          col = cols[_i];
          sep = col.split(":");
          key = sep[0];
          val = sep[1];
          item[key] = val;
        }
        states[item.ILID] = item;
      }
      try {
        return callback(null, states);
      } catch (_error) {
        e = _error;
        console.log("Problem running getstates!");
        return callback(e);
      }
    });
  };
  if (!isWatching) {
    isWatching = true;
    watchDir = "/tmp/";
    watcher = fs.watch(watchDir, function(event, filename) {
      if (filename.lastIndexOf("BChannelState", 0) === 0) {
        if (!wait) {
          return runGetStates();
        }
      }
    });
  }
  if (!wait) {
    return runGetStates();
  }
};

exports.stop = function() {
  isWatching = false;
  return watcher.close();
};

exports.getStatus = function(callback) {
  return exports.start(callback);
};
