// Generated by CoffeeScript 1.8.0
'use strict';
var exec, formattedTodayString, fs, isWatching, logger, _;

exec = require("child_process").exec;

fs = require('fs');

_ = require("lodash");

logger = require("omg-logger");

formattedTodayString = function() {
  var currentDate, day, month, year;
  currentDate = new Date();
  year = currentDate.getFullYear();
  month = currentDate.getMonth() + 1;
  month = ("0" + month).slice(-2);
  day = currentDate.getDate();
  day = ("0" + day).slice(-2);
  return "" + year + month + day;
};

isWatching = false;

exports.start = function(callback) {
  var checkValidity, getLicInfo, outOfDateLics, throttledValidityCheck, watchDir, watcher;
  outOfDateLics = [];
  checkValidity = function() {
    var amountOfLicenseFiles, checkOneLicFile, checkedFilesCounter, file, filesInData, licenseFiles, licfile, _i, _len, _results;
    logger.debug("license changed, checking validity");
    outOfDateLics = [];
    filesInData = fs.readdirSync("/data/");
    licenseFiles = (function() {
      var _i, _len, _results;
      _results = [];
      for (_i = 0, _len = filesInData.length; _i < _len; _i++) {
        file = filesInData[_i];
        if (file.match(/\.fle/)) {
          _results.push(file);
        }
      }
      return _results;
    })();
    amountOfLicenseFiles = licenseFiles.length;
    checkedFilesCounter = 0;
    checkOneLicFile = function(licfile) {
      return exec("licinfo -d -l " + licfile + " 2>&1", {
        cwd: "/data/"
      }, function(error, stdout) {
        var isExpired, licExpirationDate, licObject, licenseDetails, line, splitLine, today, _i, _len;
        checkedFilesCounter++;
        licObject = {};
        if (stdout) {
          stdout = stdout.split("\n");
          for (_i = 0, _len = stdout.length; _i < _len; _i++) {
            line = stdout[_i];
            splitLine = line.split(":");
            if (splitLine[0]) {
              licObject[splitLine[0]] = splitLine[3];
            }
          }
        }
        licExpirationDate = licObject["0DateLimit"];
        today = formattedTodayString();
        isExpired = false;
        if (licExpirationDate && licExpirationDate < today) {
          isExpired = true;
        }
        licenseDetails = {
          serial: licObject["0SerialCode"],
          expirationDate: licExpirationDate
        };
        if (isExpired) {
          outOfDateLics.push(licenseDetails);
        }
        return getLicInfo("noDiff");
      });
    };
    _results = [];
    for (_i = 0, _len = licenseFiles.length; _i < _len; _i++) {
      licfile = licenseFiles[_i];
      _results.push(checkOneLicFile(licfile));
    }
    return _results;
  };
  getLicInfo = function(noDiff) {
    return exec("licinfo -d 2>&1", function(error, stdout, stderr) {
      var line, newstdout, splitLine, _i, _len;
      if (error) {
        logger.error(error);
      }
      if (stderr) {
        console.log(stderr);
      }
      newstdout = {};
      if (stdout) {
        stdout = stdout.split("\n");
        for (_i = 0, _len = stdout.length; _i < _len; _i++) {
          line = stdout[_i];
          splitLine = line.split(":");
          if (splitLine[0]) {
            newstdout[splitLine[0]] = splitLine[3];
          }
        }
        newstdout.outOfDate = outOfDateLics;
        if (!noDiff) {
          callback(null, newstdout);
        }
        if (noDiff) {
          return callback(null, newstdout, true);
        }
      } else if (error) {
        if (error) {
          logger.error(error);
        }
        return callback(error);
      } else if (stderr) {
        console.log(stderr);
        return callback(stderr);
      }
    });
  };
  if (!isWatching) {
    checkValidity();
    getLicInfo();
    isWatching = true;
    watchDir = "/data/";
    throttledValidityCheck = _.throttle(checkValidity, 100, {
      trailing: false
    });
    watcher = fs.watch(watchDir, function(event, filename) {
      if (filename.match(/\.fle|\.flf/)) {
        throttledValidityCheck();
      }
    });
  }
};
