var exec = require('child_process').exec;
var _ = require('underscore');
var _s = require('underscore.string');

//var config = require("./config.js");
_s.includes	= _s.include;

//	THE CLIENT SHOULD DO ALL THE CALCULATIONS!!!!!
//  will return: array of arrays:
// [ ['current', 'high', 'critical'] ]
// [ [ '51.0', null, '99.0' ], [ '56.0', '86.0', '100.0' ], [ '60.0', '86.0', '100.0' ] ]

//pass config for exec, or use defaults.
var hasSensors=true;

exports.sensors = function(callback, config){
	config = config || {
		execOptions: {
			encoding: 'utf8',
			timeout: 5000,
			maxBuffer: 200*1024,
			killSignal: 'SIGTERM',
			cwd: null,
			env: null
		}
	};

	if(hasSensors){

		exec("LC_ALL=C sensors", config.execOptions, function(error,stdout, stderr){
			if(error){
				hasSensors=false;
				return callback(error, null);
			}

			if(stderr){
				hasSensors=false;
				return callback(new Error(stderr), null);
			}

			var lines = _s.lines(stdout);
			lines = _.filter(lines,function(line){			//reduce lines to those that include some requirements
				return (_s.startsWith(line,'Core ') || _s.startsWith(line, "temp"))	&&
				_s.includes(line," C ") &&
				_s.includes(line,":") &&
				_s.includes(line,"+");
			});
			//abort here! send to client!!//	THE CLIENT SHOULD DO ALL THE CALCULATIONS!

			return callback(null,lines);
		});
	}
};