-- sudo luarocks install luajson
function printJs(str)
    print(json.encode(str))
end

function probeDNS(address)
    local result={}
    start=os.time()
    result["valid"]=os.captureN("LC_ALL=C /usr/bin/nslookup -q=any "..address.." "..address.."  | grep -q ';; connection timed out; no servers could be reached' && echo false || echo true")
    stop=os.time()

    result["address"]=address
    result["elapsed"]="("..os.difftime(os.time(),start).."s)"
    return result
end

function string:split( inSplitPattern, outResults )
      if not outResults then
        outResults = { }
      end
      local theStart = 1
      local theSplitStart, theSplitEnd = string.find( self, inSplitPattern, theStart )
      while theSplitStart do
        table.insert( outResults, string.sub( self, theStart, theSplitStart-1 ) )
        theStart = theSplitEnd + 1
        theSplitStart, theSplitEnd = string.find( self, inSplitPattern, theStart )
      end
      table.insert( outResults, string.sub( self, theStart ) )
      return outResults
end
function stdout2KVtable(cmd,delim)
    local myTable={}
    local i=1
    stdout=os.capture("LC_ALL=C "..cmd,true)
    for line in stdout:gmatch("[^\n\r]+")do
        line = string.gsub(line, '\'', '"')
        myTable[i]={}
        local c=1
        for str in string.gmatch(line, "([^%s]+)") do
            myTable[i][c]=str
            c=c+1
        end
        i=i+1
    end
    return myTable
end


function cmd2kvTable(cmd,delim,valueIndex)
    myTable={}
    mySplit={}
    stdout=os.capture("LC_ALL=C "..cmd.." 2>&1",true)
    for line in stdout:gmatch("[^\n\r]+")do
        if(line ~= nil) then
            mySplit=Split(line,delim)
            if(mySplit[1] ~= nil) then
                myTable[mySplit[1]]=mySplit[valueIndex]
            end
        end
    end
    return myTable
end

function Split(str, delim, maxNb)
    -- Eliminate bad cases...
    if string.find(str, delim) == nil then
        return { str }
    end
    if maxNb == nil or maxNb < 1 then
        maxNb = 0    -- No limit
    end
    local result = {}
    local pat = "(.-)" .. delim .. "()"
    local nb = 0
    local lastPos
    for part, pos in string.gfind(str, pat) do
        nb = nb + 1
        result[nb] = part
        lastPos = pos
        if nb == maxNb then break end
    end
    -- Handle the last field
    if nb ~= maxNb then
        result[nb + 1] = string.sub(str, lastPos)
    end
    return result
end


function stdout2table(cmd)
    local myTable={}
    local i=1
    stdout=os.capture("LC_ALL=C "..cmd,true)
    for line in stdout:gmatch("[^\n\r]+")do
   	    line = string.gsub(line, '\'', '"')
        myTable[i]=line
        i=i+1
    end
    return myTable
end




function file_exists(name)
   local f=io.open(name,"r")
   if f~=nil then io.close(f) 
       return true 
   else 
       return false end
end


function os.captureN(cmd, raw)
  local f = assert(io.popen(cmd, 'r'))
  local s = assert(f:read('*a'))
  f:close()
  if raw then return s end
      s = string.gsub(s, '^%s+', '')
      s = string.gsub(s, '%s+$', '')
      s = string.gsub(s, '[\n\r]+', ' ')
  return s
end

function os.capture(cmd, raw)
  local f = assert(io.popen(cmd, 'r'))
  local s = assert(f:read('*a'))
  f:close()
  if raw then return s end
--      s = string.gsub(s, '^%s+', '')
--      s = string.gsub(s, '%s+$', '')
--      s = string.gsub(s, '[\n\r]+', ' ')
  return s
end

