#!/usr/bin/luaweb
require("json")
require("lfs")



-- local file = io.open("test.txt", "w")
-- file:write(lfs.currentdir())
-- file:close()


dofile("lua/helpers.inc")
dofile("/data/config.lua")

local data={}

data.routing=stdout2KVtable("LC_ALL=C /sbin/route -n 2>&1 | sed -e '1,1d' - ","\t")
data.config=config

--data.resolvconf=stdout2table("cat /etc/resolv.conf | grep -v ^# | grep -v '^;'")

data.Dchannels=stdout2table("getchannels -m -d 2>&1 | sort -V | grep -v 'Channels found'");
data.Bchannels=stdout2table("getchannels -m -b 2>&1 | sort -V | grep -v 'Channels found'");

data.licinfo=cmd2kvTable("licinfo -d",":",4)

data.interfaces=stdout2table('ifconfig -a | grep ^eth  | cut -d " " -f 1')

data.featureVersion=os.captureN('cat /tmp/cmdline   2>/dev/null| grep FEATUREVERSION= | sed s/.*=//g')

data.omgsysteminfo=json.decode(os.captureN("omgsysteminfo --json 2>/dev/null"))

data.kernel=os.capture('uname -r | tr -d "\n"')

data.localCertValid=os.captureN('[ -e /data/cert.pem ] && openssl x509 -in /data/cert.pem -noout -enddate | awk -F "=" \'{print $2}\' | awk -F " " \'{print $1" "$2" "$4" "$5}\' || echo No Cert found!')
data.localCertSubject=os.captureN('openssl x509 -in /data/cert.pem -noout -subject 2>/dev/null');

data.localCertSubject = string.gsub(data.localCertSubject,"subject= /CN=","")


data.nameservers={}
data.nameservers.plain=stdout2table('cat /etc/resolv.conf | grep -v ^#')
local servers = stdout2table('cat /etc/resolv.conf | grep ^nameserver | awk -F " " \'{print $2}\'')
local resolveTable={}
for k,address in pairs(servers) do
	resolveTable[k]=probeDNS(address)
end
data.nameservers.stats=resolveTable


print(json.encode(data));
