/*
 * omg-statics
 *
 * Copyright (c) 2014 Johannes Noe
 * Licensed under the MIT license.
 */

'use strict';

var exec = require('child_process').exec;
var logger = require("omg-logger");
var os = require("os");
var _ = require("lodash");

exports.start = function(next) {
    exec(__dirname + "/lua/staticJson.lua", {
        cwd: __dirname
    }, function(error, stdout) { //, stderr omitted
        try {
            var js = JSON.parse(stdout);
            js.hostname = os.hostname();
            next(null, js);
        } catch (e) {
            console.log("STATICJSON(lua):" + e.message);
            logger.error(e.message);
            next(e); // just for grunt/mocha
        }
    });
};