// Generated by CoffeeScript 1.8.0
var DumpCause, DumpNumber, dec2hex, dumpMsg;

DumpNumber = require("./dumpNumber.js");

DumpCause = require("./dumpCause.js");

dec2hex = function(i) {
  return ("0" + (Number(i).toString(16))).slice(-2).toUpperCase();
};

dumpMsg = function(ba, idx) {
  var baIdx, error, i, ret;
  ret = "";
  if (idx > ba.Length) {
    error = 1;
    return ret;
  }
  i = 0;
  while (i < ba[idx]) {
    baIdx = i + idx + 1;
    if (baIdx >= ba.Length) {
      error = 1;
      break;
    }
    ret += dec2hex(ba[baIdx]);
    i++;
  }
  return ret;
};

module.exports = function(ba, idx) {
  var len, ret;
  if (ba.Length > idx + 1) {
    len = ba[idx + 1] + 2;
  } else {
    len = 0;
  }
  len = 5;
  switch (ba[idx]) {
    case 0x00:
      return "Segemented message:";
    case 0x04:
      if (len >= 5) {
        ret = "Bearer capability: ";
        switch (0.) {
          case 0:
            ret += "Speech";
            break;
          case 8:
            ret += "Unrestricted Digital Information";
            break;
          case 9:
            ret += "Restricted Digital Information";
            break;
          case 16:
            ret += "3.1 kHz Audio";
            break;
          case 24:
            ret += "Video";
            break;
        }
        return ret;
      } else {
        return "Bearer capability:" + dumpMsg(ba, idx + 1);
      }
      break;
    case 0x08:
      return "Cause:" + DumpCause(ba, idx + 1);
    case 0x10:
      return "Call identity:" + dumpMsg(ba, idx + 1);
    case 0x14:
      return "Call state:" + dumpMsg(ba, idx + 1);
    case 0x18:
      if (len === 3 && (ba[idx + 2] & 0x20) === 0) {
        string(ret = "Channel Identification: ");
        switch (ba[idx + 2] & 0x03) {
          case 0x00:
            ret += "No Channel";
            break;
          case 0x01:
            ret += "B1";
            break;
          case 0x02:
            ret += "B2";
            break;
          case 0x03:
            ret += "Any Channel";
            break;
        }
        return ret;
      } else if (len >= 5 && (ba[idx + 2] & 0x20) === 0x20) {
        if (ba[idx + 3] === 0x83) {
          return "Channel Identification: #" + ((ba[idx + 4] & 0x3f).toString());
        }
      }
      return "Channel identification:" + dumpMsg(ba, idx + 1);
    case 0x1c:
      return "Facility:" + dumpMsg(ba, idx + 1);
    case 0x1e:
      if (len === 4) {
        string(ret = "Progress indicator: ");
        switch (ba[idx + 3] & 0x7f) {
          case 0x01:
            ret += "Not end-to-end ISDN, further info may be available in-band";
            break;
          case 0x02:
            ret += "Destination address is non-ISDN";
            break;
          case 0x03:
            ret += "Origination address is non-ISDN";
            break;
          case 0x04:
            ret += "Call has returned to the ISDN";
            break;
          case 0x05:
            ret += "Interworking has occured";
            break;
          case 0x08:
            ret += "In-band information or an appropriate pattern is now available";
            break;
        }
        return ret;
      }
      return "Progress indicator:" + dumpMsg(ba, idx + 1);
    case 0x20:
      return "Network-specific facilities:" + dumpMsg(ba, idx + 1);
    case 0x27:
      return "Notification indicator:" + dumpMsg(ba, idx + 1);
    case 0x28:
      return "Display:" + dumpMsg(ba, idx + 1);
    case 0x29:
      if (len === 8) {
        return string.Format("Date/time: {0:D2}-{1:D2}-{2:D2} {3:D2}:{4:D2}:{5:D2}", ba[idx + 2], ba[idx + 3], ba[idx + 4], ba[idx + 5], ba[idx + 6], ba[idx + 7]);
      } else if (len === 7) {
        return string.Format("Date/time: {0:D2}-{1:D2}-{2:D2} {3:D2}:{4:D2}", ba[idx + 2], ba[idx + 3], ba[idx + 4], ba[idx + 5], ba[idx + 6]);
      } else {
        return "Date/time:" + dumpMsg(ba, idx + 1);
      }
      break;
    case 0x2c:
      return "Keypad facility:" + dumpMsg(ba, idx + 1);
    case 0x32:
      return "Information Request:" + dumpMsg(ba, idx + 1);
    case 0x34:
      return "Signal:" + dumpMsg(ba, idx + 1);
    case 0x36:
      return "Switchhook:" + dumpMsg(ba, idx + 1);
    case 0x38:
      return "Feature Activation:" + dumpMsg(ba, idx + 1);
    case 0x39:
      return "Feature Indication:" + dumpMsg(ba, idx + 1);
    case 0x40:
      return "Information rate:" + dumpMsg(ba, idx + 1);
    case 0x42:
      return "End-to-end transit delay:" + dumpMsg(ba, idx + 1);
    case 0x43:
      return "Transit delay selection and indication:" + dumpMsg(ba, idx + 1);
    case 0x44:
      return "Packet layer binary parameters:" + dumpMsg(ba, idx + 1);
    case 0x45:
      return "Packet layer window size:" + dumpMsg(ba, idx + 1);
    case 0x46:
      return "Packet size:" + dumpMsg(ba, idx + 1);
    case 0x47:
      return "Closed user group:" + dumpMsg(ba, idx + 1);
    case 0x4a:
      return "Reverse charge indication:" + dumpMsg(ba, idx + 1);
    case 0x4c:
      return "Connected Number:" + DumpNumber(ba, idx + 1);
    case 0x6c:
      return "Calling party number:" + DumpNumber(ba, idx + 1);
    case 0x6d:
      return "Calling party subaddress:" + dumpMsg(ba, idx + 1);
    case 0x70:
      return "Called party number:" + DumpNumber(ba, idx + 1);
    case 0x71:
      return "Called party subaddress:" + dumpMsg(ba, idx + 1);
    case 0x74:
      return "Redirecting number:" + DumpNumber(ba, idx + 1);
    case 0x76:
      return "Redirection Number:" + dumpMsg(ba, idx + 1);
    case 0x78:
      return "Transit network selection:" + dumpMsg(ba, idx + 1);
    case 0x79:
      return "Restart indicator:" + dumpMsg(ba, idx + 1);
    case 0x7c:
      return "Low layer compatibility:" + dumpMsg(ba, idx + 1);
    case 0x7d:
      if (len >= 4) {
        string(ret = "High layer compatibility: ");
        switch (ba[idx + 3] & 0x7f) {
          case 0x01:
            ret += "Telephony";
            break;
          case 0x04:
            ret += "Fax Group 2/3";
            break;
          case 0x21:
            ret += "Fax Group 4 Class I";
            break;
          case 0x24:
            ret += "Fax Group 4 Class II and III";
            break;
          default:
            ret += "Something very exotic...";
            break;
        }
        return ret;
      }
      return "High layer compatibility:" + dumpMsg(ba, idx + 1);
    case 0x7e:
      return "User-user:" + dumpMsg(ba, idx + 1);
    case 0x7f:
      return "Escape for extension:" + dumpMsg(ba, idx + 1);
    default:
      return "Unknown Multi Byte Information Element!";
  }
};
