// Generated by CoffeeScript 1.8.0
"use strict";
var AggConnection, EventEmitter, Testcall, appConfig, callProcess, callTries, exec, exportThis, freeport, gatelogs, l2xConverter, logger, loglines, runAsRoot, shell, spawn, testcallFolder, _,
  __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

exec = require("child_process").exec;

spawn = require("child_process").spawn;

_ = require("lodash");

freeport = require("freeport");

shell = require("shelljs");

logger = require("omg-logger");

EventEmitter = require('events').EventEmitter;

appConfig = global.appConfig;

if (appConfig) {
  runAsRoot = appConfig.sudo || false;
}

AggConnection = require('./aggConnection.js');

gatelogs = new AggConnection("gatelogs");

l2xConverter = require('./l2xconverter.js');

testcallFolder = "/tmp/testcall";

if (!shell.test("-e", testcallFolder)) {
  shell.mkdir(testcallFolder);
}

shell.cp("-f", __dirname + "/files/*", "" + testcallFolder + "/");

callProcess = void 0;

callTries = 0;

loglines = [];

Testcall = (function(_super) {
  __extends(Testcall, _super);

  function Testcall() {
    this.start = __bind(this.start, this);
    this.running = false;
  }

  Testcall.prototype.start = function(callObject, startCallback, outputCallback) {
    var logsDuringCall, startCall, that;
    that = this;
    startCallback();
    logsDuringCall = [];
    startCall = function() {
      var callingPartyName, optionsPath, redirectedNumber, sippOptions;
      exec("rm -f " + testcallFolder + "/*.log", function() {});
      redirectedNumber = callObject.redirectedNumber;
      callingPartyName = callObject.callerName;
      optionsPath = "" + testcallFolder + "/options.xml";
      if (redirectedNumber && !callingPartyName) {
        optionsPath = "" + testcallFolder + "/options_redirected.xml";
      }
      if (!redirectedNumber && callingPartyName) {
        optionsPath = "" + testcallFolder + "/options_callername.xml";
      }
      if (redirectedNumber && callingPartyName) {
        optionsPath = "" + testcallFolder + "/options_callername_redirected.xml";
      }
      sippOptions = ["-skip_rlimit -silent -max_socket 50000 -sf " + optionsPath + " -mp 6000 -trace_msg -trace_shortmsg -trace_logs -trace_err -m 1 -users 1 -pause_msg_ign"];
      return exec(__dirname + "/bash/primaryAddress.sh", function(error, stdout) {
        var localAddress, msg;
        localAddress = void 0;
        msg = void 0;
        if (error) {
          msg = "Could not dertermine localAddress! (" + __dirname + "/bash/primaryAddress.sh failed!)";
          logger.error(msg);
          throw new Error(msg);
        }
        localAddress = stdout.replace(/\n/g, "");
        return freeport(function(error) {
          var argCmd, args, command, onGatelogsMessage;
          if (error) {
            msg = "Could not dertermine free local port!";
            logger.error(msg);
            throw new Error(msg);
          }
          if (runAsRoot) {
            command = "sudo";
            args = ["sipp"];
          } else {
            command = "sipp";
            args = [];
          }
          args.push("" + callObject.host + ":" + callObject.port);
          switch (callObject.proto.toUpperCase()) {
            case "TCP":
              args.push("-t t1");
              break;
            case "TLS":
              args.push("-t l1");
              break;
            case "UDP":
              args.push("-t u1");
          }
          args.push("-i " + localAddress);
          args.push("-mi " + localAddress);
          args.push("-s " + callObject.calledPartyNumber);
          args.push("-set callingPartyNumber " + callObject.callingPartyNumber);
          if (redirectedNumber) {
            args.push("-set redirectedNumber " + redirectedNumber);
          }
          if (callingPartyName) {
            args.push("-set callingPartyName " + callingPartyName);
          }
          argCmd = args.concat(sippOptions);
          argCmd = argCmd.join(" ").split(new RegExp(" "));
          logger.info("running testcall:\n " + command + " " + (argCmd.join(' ')));
          callProcess = spawn(command, argCmd, {
            cwd: "/tmp/"
          });
          callProcess.on("error", function(err) {
            logger.error("testcall spawn error on: " + argCmd);
            outputCallback(err);
          });
          callProcess.stderr.on("data", function(data) {
            var match;
            data = data.toString("utf-8");
            match = data.match("Address already in use");
            if (match) {
              if (callTries < 1) {
                callTries++;
                that.stop(function() {
                  logger.warn("Killing running testcall and trying again.");
                  outputCallback(null, "Killing running testcall and trying again.");
                  return setTimeout(that.start(callObject, startCallback, outputCallback), 2000);
                });
              } else {
                that.stop(function() {
                  callTries = 0;
                  logger.warn("Too many retries, canceling!");
                  outputCallback(null, "Too many retries, canceling!");
                });
              }
            }
          });
          callProcess.stdout.on("data", function(data) {});
          onGatelogsMessage = function(message) {
            var outArray;
            outArray = [];
            _.each(message.outputMessage, function(line, index) {
              var hexString, l3Line, l3dLines, newLine, splitLine, splitNewLine, time;
              if (line.match(/L2X/i)) {
                splitLine = line.split(":");
                hexString = splitLine.pop();
                line = splitLine.join(":");
                l3dLines = l2xConverter(hexString);
                if (l3dLines && l3dLines.length) {
                  l3Line = l3dLines[0];
                  newLine = "" + line + ": " + l3Line;
                  newLine = newLine.split("L2X : ")[1];
                  splitNewLine = newLine.split(" ");
                  time = splitNewLine[1];
                  time = time.replace(/\.|\,/g, ":");
                  splitNewLine[1] = "" + time + " ";
                  newLine = splitNewLine.join(" ");
                  outArray.push(newLine);
                  l3dLines.shift();
                  return _.each(l3dLines, function(l3Line, index) {
                    return outArray.push("                            " + l3Line);
                  });
                }
              }
            });
            if (outArray.length) {
              outputCallback(null, outArray);
            }
            if (message.status && message.status === "stopped") {
              outputCallback("regular stop");
              return that.emit("status", "stopped");
            }
          };
          gatelogs.onSub(onGatelogsMessage);
          callProcess.on("close", function(code) {
            logger.info("closing " + code);
            that.emit("shutItAllDown", code);
          });
          return that.once("shutItAllDown", function(code) {
            var errorCode, stopGatelogs;
            if (callProcess !== undefined && callProcess.killed !== true) {
              callProcess.kill();
              errorCode = 1;
            }
            stopGatelogs = function() {
              return gatelogs.stop();
            };
            return setTimeout(stopGatelogs, 1000);
          });
        });
      });
    };
    gatelogs.getStatus(function(status) {
      if (status !== "running") {
        logger.info("Gatelogs not running, starting it.");
        gatelogs.start(1);
        return gatelogs.subSocket.once("message", function(message) {
          return startCall();
        });
      } else {
        return startCall();
      }
    });
  };

  Testcall.prototype.stop = function(callback) {
    this.emit("shutItAllDown", "manual stop");
    exec("/usr/bin/killall -s 9 sipp >/dev/null 2>&1; echo -n $?", function(err) {
      if (!err) {

      } else {
        logger.error(err);
      }
    });
  };

  Testcall.prototype.getStatus = function(callback) {
    var isRunning, status;
    status = "stopped";
    isRunning = callProcess !== undefined && callProcess.killed !== true;
    if (isRunning) {
      status = "running";
    }
    if (callback) {
      callback(null, status);
    }
    return status;
  };

  return Testcall;

})(EventEmitter);

exportThis = new Testcall();

process.on("exit", function() {
  if (callProcess) {
    return callProcess.kill();
  }
});

module.exports = exportThis;
