var morgan = require('morgan');
var bodyParser = require('body-parser');
// var session = require('express-session');
var methodOverride = require('method-override');
var favicon = require('serve-favicon');
var _ = require("lodash");


var environment = require("/data/config.json").environment;
var omg = {};
var modulesNeeded = ['logger', 'ziplogs'];

if (environment === "dev") {
    _.each(modulesNeeded, function(modName) {
        omg[modName] = require("../../omg-" + modName + "/");
    });
} else if (environment === "prod") {
    _.each(modulesNeeded, function(modName) {
        omg[modName] = require("omg-" + modName);
    });
}

var logger = omg.logger;
var ziplogs = omg.ziplogs;

var fs = require('fs');

var array = fs.readFileSync('/usr/fb/omgwww.htpasswd').toString().split("\n");
var htpasswds = {};

for (var i in array) {
    var split = array[i].split(":") || [];
    htpasswds[split[0]] = split[1];
}

var pass = require("pass");

var authenticator = function(req, res, next) {

    var auth;
    // check whether an autorization header was send
    if (req.headers.authorization) {
        // only accepting basic auth, so:
        // * cut the starting "Basic " from the header
        // * decode the base64 encoded username:password
        // * split the string at the colon
        // -> should result in an array
        auth = new Buffer(req.headers.authorization.substring(6), 'base64').toString().split(':');

    }

    function tryAgain() {
        // send an Basic Auth request (HTTP Code: 401 Unauthorized)
        res.statusCode = 401;
        // MyRealmName can be changed to anything, will be prompted to the user
        res.setHeader('WWW-Authenticate', 'Basic realm="OfficeMaster Gate"');
        // this will displayed in the browser when authorization is cancelled
        res.end('Unauthorized');
    }

    // checks if auth array exists
    if (!auth || !auth[0] || !auth[1]) {
        tryAgain();
    } else {
        var password = auth[1],
            username = auth[0],
            hash = htpasswds[username];
        pass.validate(password, hash, function(error, success) {
            if (error) {
                logger.error("Login failed: " + error.message);
                tryAgain();
            }
            if (success) {
                next();
            } else { //no erro, no success
                tryAgain();
            }
        });
    }
};

module.exports = function(app, express, path) {
    app.use(authenticator);

    app.use(express.static(path)); // set the static files location /public/img will be /img for users
    // app.use(express.static(__dirname + '/../webApp/simpleTest/'));           // set the static files location /public/img will be /img for users
    app.use(morgan('dev')); // log every request to the console
    app.use(bodyParser()); // pull information from html in POST
    app.use(methodOverride()); // simulate DELETE and PUT
    app.use(express["static"](__dirname + './../webclient/app'));
    try {
        app.use(favicon(path + '/assets/favicon.ico'));
    } catch (e) {
        logger.info("could not load favicon (" + e.message + ")");
    }
    app.use("/export", ziplogs)
    app.get('/ferrariMIB', function(req, res) {
        var file = '/usr/share/snmp/mibs/FERRARI-ELECTRONIC-MIB.txt';
        res.download(file); // Set disposition and send it.
    });
};