//(Express 4.0)


var _ = require("lodash");

var environment = require("/data/config.json").environment;
var omg = {};
var modulesNeeded = ['logger'];

if (environment === "dev") {
    _.each(modulesNeeded, function(modName) {
        omg[modName] = require("../../omg-" + modName + "/");
    });
} else if (environment === "prod") {
    _.each(modulesNeeded, function(modName) {
        omg[modName] = require("omg-" + modName);
    });
}

var logger = omg.logger;
var config = require("/data/config.json").server;
var express = require('express');
var app = express();
var expressServer = app.listen(config.port);

exports.http = function(pathToPublicHtmlFolder, callback) {
    var http = require("./expressConfig")(app, express, pathToPublicHtmlFolder);
    logger.debug("server listening on " + config.port);
    if (callback) {
        callback(null, http);
    }
};


var io = require("socket.io").listen(expressServer);

io.set("log level", 1);
io.set('close timeout', 60 * 60 * 24); // 24h time out*/


exports.emitReplace = function(room, path, data) {
    io.sockets.in(room).emit("data:replace", path, data);

    // var replaced = helperfunctions.replaceByString(json, path, data); //TODO: ASYNC!
    // if (replaced) {
    //     logger.warn("replace: " + path + ":" + data)
    // } else {
    //     logger.error("useless data from agg?! in Room: " + room);
    //     console.log(data)
    //     //throw "terror";
    // }


};

exports.emitData = function(client, data) {
    // io.sockets.socket(client).emit('data', JSON.parse(data));
};

exports.emitUpdate = function(room, update) {
    if (io.sockets.clients(room).length) {
        io.sockets.in(room).emit("data", update);
    } else {
        console.log("room empty: " + room);
    }
};

exports.io = io;