/*
 * omg-ziplogs
 *
 * Copyright (c) 2014 Noe
 * Licensed under the MIT license.
 */

'use strict';

var _ = require("lodash");
var fs = require('fs');

var environment = require("/data/config.json").environment;
var omg = {};

var logger = require("omg-logger");

module.exports = function(req, res) {
    var walkSync = function(dir, beginsWith) {
        var results = [];
        var allFiles = fs.readdirSync(dir);
        _.each(allFiles, function(file) {
            var stat = fs.statSync(dir + file);
            if (stat && stat.isDirectory()) {

            } else {
                if (beginsWith && file.lastIndexOf(beginsWith) > -1) {
                    results.push(dir + file);
                }
                if (!beginsWith) {
                    results.push(dir + file)
                }
                logger.debug("found file " + JSON.stringify(file));
            }
        });
        return results
    }

    var filesFromData = walkSync("/data/");
    var coreDumpFiles = walkSync("/usr/fb/bin/sipisdn/", "core");
    var logFiles = ["/tmp/logs"];

    // Options -r recursive;  - redirect to stdout
    var args = ['-r', '-'];
    args = args.concat(filesFromData);
    args = args.concat(coreDumpFiles);
    args = args.concat(logFiles);

    var spawn = require('child_process').spawn;

    var zip = spawn('zip', args);

    res.set('Content-Type', 'application/zip');
    res.set('Content-Disposition', 'attachment; filename=OMG_Export.zip');
    // res.set('Content-Length', data.length);

    // Keep writing stdout to res
    zip.stdout.on('data', function(data) {
        res.write(data);
    });

    zip.stderr.on('data', function(data) {
        // Uncomment to see the files being added
        console.log('zip stderr: ' + data);
    });

    // End the response on zip exit
    zip.on('exit', function(code) {
        if (code !== 0) {
            // res.statusCode = 500;
            console.log('zip process exited with code ' + code);
            res.end();
        } else {
            res.end();
        }
    });
}