// Generated by CoffeeScript 1.8.0

/*
	omg-webtozmqproxys
	Copyright (c) 2014 Noe
	Licensed under the MIT license.
 */
'use strict';
var aggConfig, environment, host, logger, modName, modulesNeeded, omg, path, pushSubscriptionSocket, requestSocket, subscriptionSocket, zmq, _i, _j, _len, _len1;

zmq = require("zmq");

path = require("path");

environment = require("/data/config.json").environment;

omg = {};

modulesNeeded = ['logger', 'server'];

if (environment === "dev") {
  for (_i = 0, _len = modulesNeeded.length; _i < _len; _i++) {
    modName = modulesNeeded[_i];
    omg[modName] = require(path.normalize(__dirname + ("/../../omg-" + modName + "/")));
  }
}

if (environment === "prod") {
  for (_j = 0, _len1 = modulesNeeded.length; _j < _len1; _j++) {
    modName = modulesNeeded[_j];
    omg[modName] = require("omg-" + modName);
  }
}

logger = omg.logger;

aggConfig = require("/data/config.json").agg;

host = aggConfig.protocol + ("://" + aggConfig.address + ":");

pushSubscriptionSocket = zmq.socket('push');

pushSubscriptionSocket.connect(host + aggConfig.subscriberPoolPort);

subscriptionSocket = zmq.socket('sub');

subscriptionSocket.connect(host + aggConfig.pubSub);

requestSocket = zmq.socket('req');

requestSocket.connect(host + aggConfig.reqRep);

exports.register = function(callback) {
  return subscriptionSocket.on("message", function(response) {
    return callback(null, response);
  });
};

exports.pubSub = {
  subscribe: function(requestObject) {
    var producer;
    logger.debug("pubSub got message: " + (JSON.stringify(requestObject)));
    producer = requestObject.producer;
    pushSubscriptionSocket.send(JSON.stringify(requestObject));
    return subscriptionSocket.subscribe(producer);
  },
  unsubscribe: function(requestObject) {
    return subscriptionSocket.unsubscribe(requestObject.producer);
  },
  execute: function(requestObject) {
    return pushSubscriptionSocket.send(JSON.stringify(requestObject));
  },
  register: function(callback) {
    return subscriptionSocket.on("message", function(response) {
      return callback(null, response);
    });
  }
};

exports.requestReply = {
  jsend: function(msg) {
    return requestSocket.send(JSON.stringify(msg));
  },
  request: function(requestObject, callback) {
    return requestSocket.send(JSON.stringify(requestObject));
  },
  register: function(callback) {
    return requestSocket.on("message", function(response) {
      return callback(null, response);
    });
  }
};
