/*
 * omg-replacerWebProxy
 *
 * Copyright (c) 2014 Johannes Noe
 * Licensed under the MIT license.
 */

'use strict';

var zmq = require("zmq");
var zmqSide = zmq.socket('sub');

// var emitReplaceOnWebsocket = require("../../../html3/lib/websocketZmqProxy.js").emitReplace;
var websocket = require(__dirname + "/../../omg-server/");

var aggConfig = require("/data/config.json").agg;

var host = aggConfig.protocol + "://" + aggConfig.address + ":" + aggConfig.replaceBroadcPort;
zmqSide.connect(host);

zmqSide.on("error", function(err) {
    throw err;
});

zmqSide.on("message", function(msg) {
    //console.log(JSON.stringify(json,undefined,4))
    //agg will send to chan: 'dynamic.test:' path:' dynamic.test.cars :         {obj}';
    msg = String(msg);
    var index = msg.indexOf(':');
    var room = msg.substring(0, index);
    var args = msg.substring(index + 1);
    var i = args.indexOf(":");
    var path = args.substring(0, i);
    var data = args.substring(i + 1);
    websocket.emitReplace(room, path, data);
});

zmqSide.rsend = function(path, data) {
    var msg;
    if (typeof(data) === "object") {
        msg = path + ":" + JSON.stringify(data);
    } else if (typeof(data) === "string") {
        msg = path + ":" + data;
    } else {
        msg = path + ":";
    }
    zmqSide.send(msg);
};

module.exports = zmqSide;

// exports.subscribe = zmqSide.subscribe;
// exports.unsubscribe = zmqSide.unsubscribe;