/*
 * omg-zmqsubscriber
 *
 * Copyright (c) 2014 Noe
 * Licensed under the MIT license.
 */

'use strict';

var zmq = require('zmq');
var updaterWebProxy = zmq.socket('sub');
var websocket = require("../../omg-server/");
var aggConfig = require("/data/config.json").agg;


var host = aggConfig.protocol + "://" + aggConfig.address + ":" + aggConfig.subDottedPort;
updaterWebProxy.connect(host);

updaterWebProxy.on("message", function(msg) {
    msg = msg.toString();

    var data = msg.split(":");
    var room = data[0];
    var update = JSON.parse(msg.substring(room.length + 1));
    // logger.info("webserver: BROADCAST TO: " + room + " -- " + __filename);
    // console.log(__filename);
    websocket.emitUpdate(room, update);
});

module.exports = updaterWebProxy;