// Generated by CoffeeScript 1.8.0
var configJson, configOutOfDate, continueStart, defaultConfig, exec, fs, path, _;

exec = require("child_process").exec;

fs = require("fs");

path = require('path');

_ = require("lodash");

defaultConfig = {
  agg: {
    address: "127.0.0.1",
    subscriberPoolPort: 9008,
    pubSub: 9009,
    reqRep: 9010,
    protocol: "tcp",
    ipcSocketPath: "ipc:///tmp/ipc_sockets/"
  },
  server: {
    port: 8080,
    logLevel: "warn",
    binPath: "webApp/bin"
  },
  logger: {
    verbose: false,
    logLevel: "warn",
    logFilePath: false
  },
  environment: "prod",
  sudo: false
};

continueStart = function(configJson) {
  var environment, httpServer, ioConnectionManager, ipcFolderPath, logger, producer, serverConfig, touchTmp;
  global.appConfig = configJson;
  environment = configJson.environment;
  serverConfig = configJson.server;
  ipcFolderPath = configJson.agg.ipcSocketPath.replace("ipc://", "");
  if (!fs.existsSync(ipcFolderPath)) {
    fs.mkdir(ipcFolderPath);
  }
  if (serverConfig.restartApache) {
    exec("service httpd start");
    delete configJson.server.restartApache;
    fs.writeFile("/data/config.json", JSON.stringify(configJson, void 0, 4));
  }
  if (environment === "dev") {
    httpServer = require("../ferrariJS/omg-server/").http(__dirname + "/" + serverConfig.buildPath);
    producer = require("../ferrariJS/omg-producermanager/");
    logger = require("../ferrariJS/omg-logger/");
  } else if (environment === "prod") {
    httpServer = require("omg-server").http(__dirname + "/" + serverConfig.binPath);
    producer = require("omg-producermanager");
    logger = require("omg-logger");
  }
  ioConnectionManager = require("./lib/ioConnectionManager.js");
  touchTmp = function() {
    return exec("touch /tmp/*", function(error, stdout, stderr) {
      if (error) {
        logger.error(error);
      }
      if (stdout) {
        logger.debug(stdout);
      }
      if (stderr) {
        logger.warn(stderr);
      }
      return logger.silly("touched tmp");
    });
  };
  return setTimeout(touchTmp, 5000);
};

if (!fs.existsSync("/data/config.json")) {
  fs.writeFileSync("/data/config.json", JSON.stringify(defaultConfig, void 0, 4));
  console.log("created default config.json");
}

configJson = require("/data/config.json");

configOutOfDate = false;

_.each(defaultConfig, function(subConfigObject, configObjectName) {
  var subConfigJson;
  if (!configJson.hasOwnProperty(configObjectName)) {
    console.log("" + configObjectName + " old");
    configOutOfDate = true;
    configJson[configObjectName] = subConfigObject;
  }
  subConfigJson = configJson[configObjectName];
  if (_.isObject(subConfigObject)) {
    return _.each(subConfigObject, function(value, propName) {
      if (!subConfigJson.hasOwnProperty(propName)) {
        console.log("" + propName + " old");
        configOutOfDate = true;
        return subConfigJson[propName] = value;
      }
    });
  }
});

if (configOutOfDate) {
  console.log("config out of date...");
  fs.writeFileSync("/data/config.json", JSON.stringify(configJson, void 0, 4));
  console.log("...config updated");
}

continueStart(configJson);
