BEGIN {
  FS=";"
  ordered="true"
  lost="false"
}

{

if (NR==1) {
  #skip header
}
else
{
  if (NR==2) {
     firstseq=$9;
     seq=$9;
  }
    
  if ($9 < seq) ordered="false";
  if ($9 > seq + 1) lost = "true"
  seq=$9;
  ssrc[$2]++;
  count++;
  if($13>j_max) j_max=$13;
  j_sum+=$13
  if($12>delta_max) delta_max=$12
  abs_skew=$14 > 0 ? $14 : -$14
  abs_skew_max=skew_max > 0 ? skew_max : -skew_max 
  if(abs_skew>abs_skew_max) skew_max=$14
}

}

END {

for (var in ssrc) {
  ssrc_count++;
  if (ssrc_count > 1) ssrc_id="multiple"; else ssrc_id=var;
  #print var, "access", ssrc[var]," times"
}

#print("SSRC,Packets,FirstSeq,Ordered,Lost,JMax,JMean,DeltaMax,DeltaMean")
printf("%s,%d,%s,%s,%s,%.2f,%.2f,%.2f,%.2f\n", ssrc_id, count, firstseq, ordered, lost, j_max, j_sum/NR, delta_max, skew_max)

}
