#!/usr/bin/luaweb
dofile('/usr/fb/tests/system_tests/tests.inc')
dofile('/usr/fb/tests/system_tests/testdefinition.lua')
require ('json')

---www-data needs to be in sudoers (getchannels)
path="/usr/fb/tests/system_tests/"

dataDir = os.getenv("DATA_DIR") or "/data"
dofile(dataDir .. "/config.lua")
result="failed"


function stdout2table(cmd)
    local myTable={}
    local i=1
    stdout=os.capture("LC_ALL=C "..cmd,true)
    for line in stdout:gmatch("[^\n\r]+")do
        line = string.gsub(line, '\'', '"')
        myTable[i]=line
        i=i+1
    end
    return myTable
end





output="json"
if(request_param("json")==nil )then
	output="json"
end


results={}
i=1

tests[5]["description"]="checking callp port "..config.struct_Box.string_SipBindPort.."/tcp..."
tests[5]["parameter"]="tcp "..config.struct_Box.string_SipBindPort

for index,test in pairs(tests)do
	description=test["description"]
	command=test["command"]
	parameter=test["parameter"]
	name=test["name"]

	--execute the test, pass args
	result=os.capture("/usr/bin/sudo "..path..command.." "..parameter)


-- create result table --
	results[i]={}
	results[i]["name"]=name
	results[i]["description"]=description
	if(result=="") then result="failed" end
	results[i]["result"]=result
	i=i+1	
end


--if run from commandLine just output all failed tests, and exit with number of failed
if(output == "stdout")then
	retval=0
	for index,result in pairs(results)do
			print(result["description"]..result["result"])
			retval=retval+1		
	end
	os.exit(retval)
end

--if run from web output json data
if(output == "json")then 
	print ("Content-type: application/json\n")
	print(json.encode(results))
end

